var ms = Object.defineProperty;
var xs = (r, t, e) => t in r ? ms(r, t, { enumerable: !0, configurable: !0, writable: !0, value: e }) : r[t] = e;
var bt = (r, t, e) => (xs(r, typeof t != "symbol" ? t + "" : t, e), e);
import { fromCodePoint as fe, StateField as es, RangeSetBuilder as ce, Facet as At, EditorState as Yt, StateEffect as bs, Prec as ss } from "@codemirror/state";
import { ViewPlugin as Bt, EditorView as at, Decoration as Q, WidgetType as ks, Direction as zt, logException as Js } from "@codemirror/view";
const is = 1024;
let ys = 0;
class Qt {
  constructor(t, e) {
    this.from = t, this.to = e;
  }
}
class b {
  /**
  Create a new node prop type.
  */
  constructor(t = {}) {
    this.id = ys++, this.perNode = !!t.perNode, this.deserialize = t.deserialize || (() => {
      throw new Error("This node type doesn't define a deserialize function");
    });
  }
  /**
  This is meant to be used with
  [`NodeSet.extend`](#common.NodeSet.extend) or
  [`LRParser.configure`](#lr.ParserConfig.props) to compute
  prop values for each node type in the set. Takes a [match
  object](#common.NodeType^match) or function that returns undefined
  if the node type doesn't get this prop, and the prop's value if
  it does.
  */
  add(t) {
    if (this.perNode)
      throw new RangeError("Can't add per-node props to node types");
    return typeof t != "function" && (t = W.match(t)), (e) => {
      let s = t(e);
      return s === void 0 ? null : [this, s];
    };
  }
}
b.closedBy = new b({ deserialize: (r) => r.split(" ") });
b.openedBy = new b({ deserialize: (r) => r.split(" ") });
b.group = new b({ deserialize: (r) => r.split(" ") });
b.isolate = new b({ deserialize: (r) => {
  if (r && r != "rtl" && r != "ltr" && r != "auto")
    throw new RangeError("Invalid value for isolate: " + r);
  return r || "auto";
} });
b.contextHash = new b({ perNode: !0 });
b.lookAhead = new b({ perNode: !0 });
b.mounted = new b({ perNode: !0 });
class Dt {
  constructor(t, e, s) {
    this.tree = t, this.overlay = e, this.parser = s;
  }
  /**
  @internal
  */
  static get(t) {
    return t && t.props && t.props[b.mounted.id];
  }
}
const ws = /* @__PURE__ */ Object.create(null);
class W {
  /**
  @internal
  */
  constructor(t, e, s, i = 0) {
    this.name = t, this.props = e, this.id = s, this.flags = i;
  }
  /**
  Define a node type.
  */
  static define(t) {
    let e = t.props && t.props.length ? /* @__PURE__ */ Object.create(null) : ws, s = (t.top ? 1 : 0) | (t.skipped ? 2 : 0) | (t.error ? 4 : 0) | (t.name == null ? 8 : 0), i = new W(t.name || "", e, t.id, s);
    if (t.props) {
      for (let n of t.props)
        if (Array.isArray(n) || (n = n(i)), n) {
          if (n[0].perNode)
            throw new RangeError("Can't store a per-node prop on a node type");
          e[n[0].id] = n[1];
        }
    }
    return i;
  }
  /**
  Retrieves a node prop for this type. Will return `undefined` if
  the prop isn't present on this node.
  */
  prop(t) {
    return this.props[t.id];
  }
  /**
  True when this is the top node of a grammar.
  */
  get isTop() {
    return (this.flags & 1) > 0;
  }
  /**
  True when this node is produced by a skip rule.
  */
  get isSkipped() {
    return (this.flags & 2) > 0;
  }
  /**
  Indicates whether this is an error node.
  */
  get isError() {
    return (this.flags & 4) > 0;
  }
  /**
  When true, this node type doesn't correspond to a user-declared
  named node, for example because it is used to cache repetition.
  */
  get isAnonymous() {
    return (this.flags & 8) > 0;
  }
  /**
  Returns true when this node's name or one of its
  [groups](#common.NodeProp^group) matches the given string.
  */
  is(t) {
    if (typeof t == "string") {
      if (this.name == t)
        return !0;
      let e = this.prop(b.group);
      return e ? e.indexOf(t) > -1 : !1;
    }
    return this.id == t;
  }
  /**
  Create a function from node types to arbitrary values by
  specifying an object whose property names are node or
  [group](#common.NodeProp^group) names. Often useful with
  [`NodeProp.add`](#common.NodeProp.add). You can put multiple
  names, separated by spaces, in a single property name to map
  multiple node names to a single value.
  */
  static match(t) {
    let e = /* @__PURE__ */ Object.create(null);
    for (let s in t)
      for (let i of s.split(" "))
        e[i] = t[s];
    return (s) => {
      for (let i = s.prop(b.group), n = -1; n < (i ? i.length : 0); n++) {
        let o = e[n < 0 ? s.name : i[n]];
        if (o)
          return o;
      }
    };
  }
}
W.none = new W(
  "",
  /* @__PURE__ */ Object.create(null),
  0,
  8
  /* NodeFlag.Anonymous */
);
class pe {
  /**
  Create a set with the given types. The `id` property of each
  type should correspond to its position within the array.
  */
  constructor(t) {
    this.types = t;
    for (let e = 0; e < t.length; e++)
      if (t[e].id != e)
        throw new RangeError("Node type ids should correspond to array positions when creating a node set");
  }
  /**
  Create a copy of this set with some node properties added. The
  arguments to this method can be created with
  [`NodeProp.add`](#common.NodeProp.add).
  */
  extend(...t) {
    let e = [];
    for (let s of this.types) {
      let i = null;
      for (let n of t) {
        let o = n(s);
        o && (i || (i = Object.assign({}, s.props)), i[o[0].id] = o[1]);
      }
      e.push(i ? new W(s.name, i, s.id, s.flags) : s);
    }
    return new pe(e);
  }
}
const kt = /* @__PURE__ */ new WeakMap(), be = /* @__PURE__ */ new WeakMap();
var V;
(function(r) {
  r[r.ExcludeBuffers = 1] = "ExcludeBuffers", r[r.IncludeAnonymous = 2] = "IncludeAnonymous", r[r.IgnoreMounts = 4] = "IgnoreMounts", r[r.IgnoreOverlays = 8] = "IgnoreOverlays";
})(V || (V = {}));
class R {
  /**
  Construct a new tree. See also [`Tree.build`](#common.Tree^build).
  */
  constructor(t, e, s, i, n) {
    if (this.type = t, this.children = e, this.positions = s, this.length = i, this.props = null, n && n.length) {
      this.props = /* @__PURE__ */ Object.create(null);
      for (let [o, a] of n)
        this.props[typeof o == "number" ? o : o.id] = a;
    }
  }
  /**
  @internal
  */
  toString() {
    let t = Dt.get(this);
    if (t && !t.overlay)
      return t.tree.toString();
    let e = "";
    for (let s of this.children) {
      let i = s.toString();
      i && (e && (e += ","), e += i);
    }
    return this.type.name ? (/\W/.test(this.type.name) && !this.type.isError ? JSON.stringify(this.type.name) : this.type.name) + (e.length ? "(" + e + ")" : "") : e;
  }
  /**
  Get a [tree cursor](#common.TreeCursor) positioned at the top of
  the tree. Mode can be used to [control](#common.IterMode) which
  nodes the cursor visits.
  */
  cursor(t = 0) {
    return new ae(this.topNode, t);
  }
  /**
  Get a [tree cursor](#common.TreeCursor) pointing into this tree
  at the given position and side (see
  [`moveTo`](#common.TreeCursor.moveTo).
  */
  cursorAt(t, e = 0, s = 0) {
    let i = kt.get(this) || this.topNode, n = new ae(i);
    return n.moveTo(t, e), kt.set(this, n._tree), n;
  }
  /**
  Get a [syntax node](#common.SyntaxNode) object for the top of the
  tree.
  */
  get topNode() {
    return new q(this, 0, 0, null);
  }
  /**
  Get the [syntax node](#common.SyntaxNode) at the given position.
  If `side` is -1, this will move into nodes that end at the
  position. If 1, it'll move into nodes that start at the
  position. With 0, it'll only enter nodes that cover the position
  from both sides.
  
  Note that this will not enter
  [overlays](#common.MountedTree.overlay), and you often want
  [`resolveInner`](#common.Tree.resolveInner) instead.
  */
  resolve(t, e = 0) {
    let s = mt(kt.get(this) || this.topNode, t, e, !1);
    return kt.set(this, s), s;
  }
  /**
  Like [`resolve`](#common.Tree.resolve), but will enter
  [overlaid](#common.MountedTree.overlay) nodes, producing a syntax node
  pointing into the innermost overlaid tree at the given position
  (with parent links going through all parent structure, including
  the host trees).
  */
  resolveInner(t, e = 0) {
    let s = mt(be.get(this) || this.topNode, t, e, !0);
    return be.set(this, s), s;
  }
  /**
  In some situations, it can be useful to iterate through all
  nodes around a position, including those in overlays that don't
  directly cover the position. This method gives you an iterator
  that will produce all nodes, from small to big, around the given
  position.
  */
  resolveStack(t, e = 0) {
    return vs(this, t, e);
  }
  /**
  Iterate over the tree and its children, calling `enter` for any
  node that touches the `from`/`to` region (if given) before
  running over such a node's children, and `leave` (if given) when
  leaving the node. When `enter` returns `false`, that node will
  not have its children iterated over (or `leave` called).
  */
  iterate(t) {
    let { enter: e, leave: s, from: i = 0, to: n = this.length } = t, o = t.mode || 0, a = (o & V.IncludeAnonymous) > 0;
    for (let l = this.cursor(o | V.IncludeAnonymous); ; ) {
      let h = !1;
      if (l.from <= n && l.to >= i && (!a && l.type.isAnonymous || e(l) !== !1)) {
        if (l.firstChild())
          continue;
        h = !0;
      }
      for (; h && s && (a || !l.type.isAnonymous) && s(l), !l.nextSibling(); ) {
        if (!l.parent())
          return;
        h = !0;
      }
    }
  }
  /**
  Get the value of the given [node prop](#common.NodeProp) for this
  node. Works with both per-node and per-type props.
  */
  prop(t) {
    return t.perNode ? this.props ? this.props[t.id] : void 0 : this.type.prop(t);
  }
  /**
  Returns the node's [per-node props](#common.NodeProp.perNode) in a
  format that can be passed to the [`Tree`](#common.Tree)
  constructor.
  */
  get propValues() {
    let t = [];
    if (this.props)
      for (let e in this.props)
        t.push([+e, this.props[e]]);
    return t;
  }
  /**
  Balance the direct children of this tree, producing a copy of
  which may have children grouped into subtrees with type
  [`NodeType.none`](#common.NodeType^none).
  */
  balance(t = {}) {
    return this.children.length <= 8 ? this : je(W.none, this.children, this.positions, 0, this.children.length, 0, this.length, (e, s, i) => new R(this.type, e, s, i, this.propValues), t.makeTree || ((e, s, i) => new R(W.none, e, s, i)));
  }
  /**
  Build a tree from a postfix-ordered buffer of node information,
  or a cursor over such a buffer.
  */
  static build(t) {
    return Rs(t);
  }
}
R.empty = new R(W.none, [], [], 0);
class de {
  constructor(t, e) {
    this.buffer = t, this.index = e;
  }
  get id() {
    return this.buffer[this.index - 4];
  }
  get start() {
    return this.buffer[this.index - 3];
  }
  get end() {
    return this.buffer[this.index - 2];
  }
  get size() {
    return this.buffer[this.index - 1];
  }
  get pos() {
    return this.index;
  }
  next() {
    this.index -= 4;
  }
  fork() {
    return new de(this.buffer, this.index);
  }
}
class et {
  /**
  Create a tree buffer.
  */
  constructor(t, e, s) {
    this.buffer = t, this.length = e, this.set = s;
  }
  /**
  @internal
  */
  get type() {
    return W.none;
  }
  /**
  @internal
  */
  toString() {
    let t = [];
    for (let e = 0; e < this.buffer.length; )
      t.push(this.childString(e)), e = this.buffer[e + 3];
    return t.join(",");
  }
  /**
  @internal
  */
  childString(t) {
    let e = this.buffer[t], s = this.buffer[t + 3], i = this.set.types[e], n = i.name;
    if (/\W/.test(n) && !i.isError && (n = JSON.stringify(n)), t += 4, s == t)
      return n;
    let o = [];
    for (; t < s; )
      o.push(this.childString(t)), t = this.buffer[t + 3];
    return n + "(" + o.join(",") + ")";
  }
  /**
  @internal
  */
  findChild(t, e, s, i, n) {
    let { buffer: o } = this, a = -1;
    for (let l = t; l != e && !(rs(n, i, o[l + 1], o[l + 2]) && (a = l, s > 0)); l = o[l + 3])
      ;
    return a;
  }
  /**
  @internal
  */
  slice(t, e, s) {
    let i = this.buffer, n = new Uint16Array(e - t), o = 0;
    for (let a = t, l = 0; a < e; ) {
      n[l++] = i[a++], n[l++] = i[a++] - s;
      let h = n[l++] = i[a++] - s;
      n[l++] = i[a++] - t, o = Math.max(o, h);
    }
    return new et(n, o, this.set);
  }
}
function rs(r, t, e, s) {
  switch (r) {
    case -2:
      return e < t;
    case -1:
      return s >= t && e < t;
    case 0:
      return e < t && s > t;
    case 1:
      return e <= t && s > t;
    case 2:
      return s > t;
    case 4:
      return !0;
  }
}
function mt(r, t, e, s) {
  for (var i; r.from == r.to || (e < 1 ? r.from >= t : r.from > t) || (e > -1 ? r.to <= t : r.to < t); ) {
    let o = !s && r instanceof q && r.index < 0 ? null : r.parent;
    if (!o)
      return r;
    r = o;
  }
  let n = s ? 0 : V.IgnoreOverlays;
  if (s)
    for (let o = r, a = o.parent; a; o = a, a = o.parent)
      o instanceof q && o.index < 0 && ((i = a.enter(t, e, n)) === null || i === void 0 ? void 0 : i.from) != o.from && (r = a);
  for (; ; ) {
    let o = r.enter(t, e, n);
    if (!o)
      return r;
    r = o;
  }
}
class ns {
  cursor(t = 0) {
    return new ae(this, t);
  }
  getChild(t, e = null, s = null) {
    let i = ke(this, t, e, s);
    return i.length ? i[0] : null;
  }
  getChildren(t, e = null, s = null) {
    return ke(this, t, e, s);
  }
  resolve(t, e = 0) {
    return mt(this, t, e, !1);
  }
  resolveInner(t, e = 0) {
    return mt(this, t, e, !0);
  }
  matchContext(t) {
    return oe(this, t);
  }
  enterUnfinishedNodesBefore(t) {
    let e = this.childBefore(t), s = this;
    for (; e; ) {
      let i = e.lastChild;
      if (!i || i.to != e.to)
        break;
      i.type.isError && i.from == i.to ? (s = e, e = i.prevSibling) : e = i;
    }
    return s;
  }
  get node() {
    return this;
  }
  get next() {
    return this.parent;
  }
}
class q extends ns {
  constructor(t, e, s, i) {
    super(), this._tree = t, this.from = e, this.index = s, this._parent = i;
  }
  get type() {
    return this._tree.type;
  }
  get name() {
    return this._tree.type.name;
  }
  get to() {
    return this.from + this._tree.length;
  }
  nextChild(t, e, s, i, n = 0) {
    for (let o = this; ; ) {
      for (let { children: a, positions: l } = o._tree, h = e > 0 ? a.length : -1; t != h; t += e) {
        let u = a[t], $ = l[t] + o.from;
        if (rs(i, s, $, $ + u.length)) {
          if (u instanceof et) {
            if (n & V.ExcludeBuffers)
              continue;
            let f = u.findChild(0, u.buffer.length, e, s - $, i);
            if (f > -1)
              return new tt(new Ts(o, u, t, $), null, f);
          } else if (n & V.IncludeAnonymous || !u.type.isAnonymous || Ue(u)) {
            let f;
            if (!(n & V.IgnoreMounts) && (f = Dt.get(u)) && !f.overlay)
              return new q(f.tree, $, t, o);
            let p = new q(u, $, t, o);
            return n & V.IncludeAnonymous || !p.type.isAnonymous ? p : p.nextChild(e < 0 ? u.children.length - 1 : 0, e, s, i);
          }
        }
      }
      if (n & V.IncludeAnonymous || !o.type.isAnonymous || (o.index >= 0 ? t = o.index + e : t = e < 0 ? -1 : o._parent._tree.children.length, o = o._parent, !o))
        return null;
    }
  }
  get firstChild() {
    return this.nextChild(
      0,
      1,
      0,
      4
      /* Side.DontCare */
    );
  }
  get lastChild() {
    return this.nextChild(
      this._tree.children.length - 1,
      -1,
      0,
      4
      /* Side.DontCare */
    );
  }
  childAfter(t) {
    return this.nextChild(
      0,
      1,
      t,
      2
      /* Side.After */
    );
  }
  childBefore(t) {
    return this.nextChild(
      this._tree.children.length - 1,
      -1,
      t,
      -2
      /* Side.Before */
    );
  }
  enter(t, e, s = 0) {
    let i;
    if (!(s & V.IgnoreOverlays) && (i = Dt.get(this._tree)) && i.overlay) {
      let n = t - this.from;
      for (let { from: o, to: a } of i.overlay)
        if ((e > 0 ? o <= n : o < n) && (e < 0 ? a >= n : a > n))
          return new q(i.tree, i.overlay[0].from + this.from, -1, this);
    }
    return this.nextChild(0, 1, t, e, s);
  }
  nextSignificantParent() {
    let t = this;
    for (; t.type.isAnonymous && t._parent; )
      t = t._parent;
    return t;
  }
  get parent() {
    return this._parent ? this._parent.nextSignificantParent() : null;
  }
  get nextSibling() {
    return this._parent && this.index >= 0 ? this._parent.nextChild(
      this.index + 1,
      1,
      0,
      4
      /* Side.DontCare */
    ) : null;
  }
  get prevSibling() {
    return this._parent && this.index >= 0 ? this._parent.nextChild(
      this.index - 1,
      -1,
      0,
      4
      /* Side.DontCare */
    ) : null;
  }
  get tree() {
    return this._tree;
  }
  toTree() {
    return this._tree;
  }
  /**
  @internal
  */
  toString() {
    return this._tree.toString();
  }
}
function ke(r, t, e, s) {
  let i = r.cursor(), n = [];
  if (!i.firstChild())
    return n;
  if (e != null) {
    for (; !i.type.is(e); )
      if (!i.nextSibling())
        return n;
  }
  for (; ; ) {
    if (s != null && i.type.is(s))
      return n;
    if (i.type.is(t) && n.push(i.node), !i.nextSibling())
      return s == null ? n : [];
  }
}
function oe(r, t, e = t.length - 1) {
  for (let s = r.parent; e >= 0; s = s.parent) {
    if (!s)
      return !1;
    if (!s.type.isAnonymous) {
      if (t[e] && t[e] != s.name)
        return !1;
      e--;
    }
  }
  return !0;
}
class Ts {
  constructor(t, e, s, i) {
    this.parent = t, this.buffer = e, this.index = s, this.start = i;
  }
}
class tt extends ns {
  get name() {
    return this.type.name;
  }
  get from() {
    return this.context.start + this.context.buffer.buffer[this.index + 1];
  }
  get to() {
    return this.context.start + this.context.buffer.buffer[this.index + 2];
  }
  constructor(t, e, s) {
    super(), this.context = t, this._parent = e, this.index = s, this.type = t.buffer.set.types[t.buffer.buffer[s]];
  }
  child(t, e, s) {
    let { buffer: i } = this.context, n = i.findChild(this.index + 4, i.buffer[this.index + 3], t, e - this.context.start, s);
    return n < 0 ? null : new tt(this.context, this, n);
  }
  get firstChild() {
    return this.child(
      1,
      0,
      4
      /* Side.DontCare */
    );
  }
  get lastChild() {
    return this.child(
      -1,
      0,
      4
      /* Side.DontCare */
    );
  }
  childAfter(t) {
    return this.child(
      1,
      t,
      2
      /* Side.After */
    );
  }
  childBefore(t) {
    return this.child(
      -1,
      t,
      -2
      /* Side.Before */
    );
  }
  enter(t, e, s = 0) {
    if (s & V.ExcludeBuffers)
      return null;
    let { buffer: i } = this.context, n = i.findChild(this.index + 4, i.buffer[this.index + 3], e > 0 ? 1 : -1, t - this.context.start, e);
    return n < 0 ? null : new tt(this.context, this, n);
  }
  get parent() {
    return this._parent || this.context.parent.nextSignificantParent();
  }
  externalSibling(t) {
    return this._parent ? null : this.context.parent.nextChild(
      this.context.index + t,
      t,
      0,
      4
      /* Side.DontCare */
    );
  }
  get nextSibling() {
    let { buffer: t } = this.context, e = t.buffer[this.index + 3];
    return e < (this._parent ? t.buffer[this._parent.index + 3] : t.buffer.length) ? new tt(this.context, this._parent, e) : this.externalSibling(1);
  }
  get prevSibling() {
    let { buffer: t } = this.context, e = this._parent ? this._parent.index + 4 : 0;
    return this.index == e ? this.externalSibling(-1) : new tt(this.context, this._parent, t.findChild(
      e,
      this.index,
      -1,
      0,
      4
      /* Side.DontCare */
    ));
  }
  get tree() {
    return null;
  }
  toTree() {
    let t = [], e = [], { buffer: s } = this.context, i = this.index + 4, n = s.buffer[this.index + 3];
    if (n > i) {
      let o = s.buffer[this.index + 1];
      t.push(s.slice(i, n, o)), e.push(0);
    }
    return new R(this.type, t, e, this.to - this.from);
  }
  /**
  @internal
  */
  toString() {
    return this.context.buffer.childString(this.index);
  }
}
function os(r) {
  if (!r.length)
    return null;
  let t = 0, e = r[0];
  for (let n = 1; n < r.length; n++) {
    let o = r[n];
    (o.from > e.from || o.to < e.to) && (e = o, t = n);
  }
  let s = e instanceof q && e.index < 0 ? null : e.parent, i = r.slice();
  return s ? i[t] = s : i.splice(t, 1), new Fs(i, e);
}
class Fs {
  constructor(t, e) {
    this.heads = t, this.node = e;
  }
  get next() {
    return os(this.heads);
  }
}
function vs(r, t, e) {
  let s = r.resolveInner(t, e), i = null;
  for (let n = s instanceof q ? s : s.context.parent; n; n = n.parent)
    if (n.index < 0) {
      let o = n.parent;
      (i || (i = [s])).push(o.resolve(t, e)), n = o;
    } else {
      let o = Dt.get(n.tree);
      if (o && o.overlay && o.overlay[0].from <= t && o.overlay[o.overlay.length - 1].to >= t) {
        let a = new q(o.tree, o.overlay[0].from + n.from, -1, n);
        (i || (i = [s])).push(mt(a, t, e, !1));
      }
    }
  return i ? os(i) : s;
}
class ae {
  /**
  Shorthand for `.type.name`.
  */
  get name() {
    return this.type.name;
  }
  /**
  @internal
  */
  constructor(t, e = 0) {
    if (this.mode = e, this.buffer = null, this.stack = [], this.index = 0, this.bufferNode = null, t instanceof q)
      this.yieldNode(t);
    else {
      this._tree = t.context.parent, this.buffer = t.context;
      for (let s = t._parent; s; s = s._parent)
        this.stack.unshift(s.index);
      this.bufferNode = t, this.yieldBuf(t.index);
    }
  }
  yieldNode(t) {
    return t ? (this._tree = t, this.type = t.type, this.from = t.from, this.to = t.to, !0) : !1;
  }
  yieldBuf(t, e) {
    this.index = t;
    let { start: s, buffer: i } = this.buffer;
    return this.type = e || i.set.types[i.buffer[t]], this.from = s + i.buffer[t + 1], this.to = s + i.buffer[t + 2], !0;
  }
  /**
  @internal
  */
  yield(t) {
    return t ? t instanceof q ? (this.buffer = null, this.yieldNode(t)) : (this.buffer = t.context, this.yieldBuf(t.index, t.type)) : !1;
  }
  /**
  @internal
  */
  toString() {
    return this.buffer ? this.buffer.buffer.childString(this.index) : this._tree.toString();
  }
  /**
  @internal
  */
  enterChild(t, e, s) {
    if (!this.buffer)
      return this.yield(this._tree.nextChild(t < 0 ? this._tree._tree.children.length - 1 : 0, t, e, s, this.mode));
    let { buffer: i } = this.buffer, n = i.findChild(this.index + 4, i.buffer[this.index + 3], t, e - this.buffer.start, s);
    return n < 0 ? !1 : (this.stack.push(this.index), this.yieldBuf(n));
  }
  /**
  Move the cursor to this node's first child. When this returns
  false, the node has no child, and the cursor has not been moved.
  */
  firstChild() {
    return this.enterChild(
      1,
      0,
      4
      /* Side.DontCare */
    );
  }
  /**
  Move the cursor to this node's last child.
  */
  lastChild() {
    return this.enterChild(
      -1,
      0,
      4
      /* Side.DontCare */
    );
  }
  /**
  Move the cursor to the first child that ends after `pos`.
  */
  childAfter(t) {
    return this.enterChild(
      1,
      t,
      2
      /* Side.After */
    );
  }
  /**
  Move to the last child that starts before `pos`.
  */
  childBefore(t) {
    return this.enterChild(
      -1,
      t,
      -2
      /* Side.Before */
    );
  }
  /**
  Move the cursor to the child around `pos`. If side is -1 the
  child may end at that position, when 1 it may start there. This
  will also enter [overlaid](#common.MountedTree.overlay)
  [mounted](#common.NodeProp^mounted) trees unless `overlays` is
  set to false.
  */
  enter(t, e, s = this.mode) {
    return this.buffer ? s & V.ExcludeBuffers ? !1 : this.enterChild(1, t, e) : this.yield(this._tree.enter(t, e, s));
  }
  /**
  Move to the node's parent node, if this isn't the top node.
  */
  parent() {
    if (!this.buffer)
      return this.yieldNode(this.mode & V.IncludeAnonymous ? this._tree._parent : this._tree.parent);
    if (this.stack.length)
      return this.yieldBuf(this.stack.pop());
    let t = this.mode & V.IncludeAnonymous ? this.buffer.parent : this.buffer.parent.nextSignificantParent();
    return this.buffer = null, this.yieldNode(t);
  }
  /**
  @internal
  */
  sibling(t) {
    if (!this.buffer)
      return this._tree._parent ? this.yield(this._tree.index < 0 ? null : this._tree._parent.nextChild(this._tree.index + t, t, 0, 4, this.mode)) : !1;
    let { buffer: e } = this.buffer, s = this.stack.length - 1;
    if (t < 0) {
      let i = s < 0 ? 0 : this.stack[s] + 4;
      if (this.index != i)
        return this.yieldBuf(e.findChild(
          i,
          this.index,
          -1,
          0,
          4
          /* Side.DontCare */
        ));
    } else {
      let i = e.buffer[this.index + 3];
      if (i < (s < 0 ? e.buffer.length : e.buffer[this.stack[s] + 3]))
        return this.yieldBuf(i);
    }
    return s < 0 ? this.yield(this.buffer.parent.nextChild(this.buffer.index + t, t, 0, 4, this.mode)) : !1;
  }
  /**
  Move to this node's next sibling, if any.
  */
  nextSibling() {
    return this.sibling(1);
  }
  /**
  Move to this node's previous sibling, if any.
  */
  prevSibling() {
    return this.sibling(-1);
  }
  atLastNode(t) {
    let e, s, { buffer: i } = this;
    if (i) {
      if (t > 0) {
        if (this.index < i.buffer.buffer.length)
          return !1;
      } else
        for (let n = 0; n < this.index; n++)
          if (i.buffer.buffer[n + 3] < this.index)
            return !1;
      ({ index: e, parent: s } = i);
    } else
      ({ index: e, _parent: s } = this._tree);
    for (; s; { index: e, _parent: s } = s)
      if (e > -1)
        for (let n = e + t, o = t < 0 ? -1 : s._tree.children.length; n != o; n += t) {
          let a = s._tree.children[n];
          if (this.mode & V.IncludeAnonymous || a instanceof et || !a.type.isAnonymous || Ue(a))
            return !1;
        }
    return !0;
  }
  move(t, e) {
    if (e && this.enterChild(
      t,
      0,
      4
      /* Side.DontCare */
    ))
      return !0;
    for (; ; ) {
      if (this.sibling(t))
        return !0;
      if (this.atLastNode(t) || !this.parent())
        return !1;
    }
  }
  /**
  Move to the next node in a
  [pre-order](https://en.wikipedia.org/wiki/Tree_traversal#Pre-order,_NLR)
  traversal, going from a node to its first child or, if the
  current node is empty or `enter` is false, its next sibling or
  the next sibling of the first parent node that has one.
  */
  next(t = !0) {
    return this.move(1, t);
  }
  /**
  Move to the next node in a last-to-first pre-order traveral. A
  node is followed by its last child or, if it has none, its
  previous sibling or the previous sibling of the first parent
  node that has one.
  */
  prev(t = !0) {
    return this.move(-1, t);
  }
  /**
  Move the cursor to the innermost node that covers `pos`. If
  `side` is -1, it will enter nodes that end at `pos`. If it is 1,
  it will enter nodes that start at `pos`.
  */
  moveTo(t, e = 0) {
    for (; (this.from == this.to || (e < 1 ? this.from >= t : this.from > t) || (e > -1 ? this.to <= t : this.to < t)) && this.parent(); )
      ;
    for (; this.enterChild(1, t, e); )
      ;
    return this;
  }
  /**
  Get a [syntax node](#common.SyntaxNode) at the cursor's current
  position.
  */
  get node() {
    if (!this.buffer)
      return this._tree;
    let t = this.bufferNode, e = null, s = 0;
    if (t && t.context == this.buffer)
      t:
        for (let i = this.index, n = this.stack.length; n >= 0; ) {
          for (let o = t; o; o = o._parent)
            if (o.index == i) {
              if (i == this.index)
                return o;
              e = o, s = n + 1;
              break t;
            }
          i = this.stack[--n];
        }
    for (let i = s; i < this.stack.length; i++)
      e = new tt(this.buffer, e, this.stack[i]);
    return this.bufferNode = new tt(this.buffer, e, this.index);
  }
  /**
  Get the [tree](#common.Tree) that represents the current node, if
  any. Will return null when the node is in a [tree
  buffer](#common.TreeBuffer).
  */
  get tree() {
    return this.buffer ? null : this._tree._tree;
  }
  /**
  Iterate over the current node and all its descendants, calling
  `enter` when entering a node and `leave`, if given, when leaving
  one. When `enter` returns `false`, any children of that node are
  skipped, and `leave` isn't called for it.
  */
  iterate(t, e) {
    for (let s = 0; ; ) {
      let i = !1;
      if (this.type.isAnonymous || t(this) !== !1) {
        if (this.firstChild()) {
          s++;
          continue;
        }
        this.type.isAnonymous || (i = !0);
      }
      for (; i && e && e(this), i = this.type.isAnonymous, !this.nextSibling(); ) {
        if (!s)
          return;
        this.parent(), s--, i = !0;
      }
    }
  }
  /**
  Test whether the current node matches a given context—a sequence
  of direct parent node names. Empty strings in the context array
  are treated as wildcards.
  */
  matchContext(t) {
    if (!this.buffer)
      return oe(this.node, t);
    let { buffer: e } = this.buffer, { types: s } = e.set;
    for (let i = t.length - 1, n = this.stack.length - 1; i >= 0; n--) {
      if (n < 0)
        return oe(this.node, t, i);
      let o = s[e.buffer[this.stack[n]]];
      if (!o.isAnonymous) {
        if (t[i] && t[i] != o.name)
          return !1;
        i--;
      }
    }
    return !0;
  }
}
function Ue(r) {
  return r.children.some((t) => t instanceof et || !t.type.isAnonymous || Ue(t));
}
function Rs(r) {
  var t;
  let { buffer: e, nodeSet: s, maxBufferLength: i = is, reused: n = [], minRepeatType: o = s.types.length } = r, a = Array.isArray(e) ? new de(e, e.length) : e, l = s.types, h = 0, u = 0;
  function $(m, J, j, T, k, x) {
    let { id: g, start: O, end: F, size: y } = a, D = u;
    for (; y < 0; )
      if (a.next(), y == -1) {
        let K = n[g];
        j.push(K), T.push(O - m);
        return;
      } else if (y == -3) {
        h = g;
        return;
      } else if (y == -4) {
        u = g;
        return;
      } else
        throw new RangeError(`Unrecognized record size: ${y}`);
    let st = l[g], ht, it, me = O - m;
    if (F - O <= i && (it = w(a.pos - J, k))) {
      let K = new Uint16Array(it.size - it.skip), C = a.pos - it.size, G = K.length;
      for (; a.pos > C; )
        G = z(it.start, K, G);
      ht = new et(K, F - it.start, s), me = it.start - m;
    } else {
      let K = a.pos - y;
      a.next();
      let C = [], G = [], rt = g >= o ? g : -1, $t = 0, xt = F;
      for (; a.pos > K; )
        rt >= 0 && a.id == rt && a.size >= 0 ? (a.end <= xt - i && (d(C, G, O, $t, a.end, xt, rt, D), $t = C.length, xt = a.end), a.next()) : x > 2500 ? f(O, K, C, G) : $(O, K, C, G, rt, x + 1);
      if (rt >= 0 && $t > 0 && $t < C.length && d(C, G, O, $t, O, xt, rt, D), C.reverse(), G.reverse(), rt > -1 && $t > 0) {
        let xe = p(st);
        ht = je(st, C, G, 0, C.length, 0, F - O, xe, xe);
      } else
        ht = S(st, C, G, F - O, D - F);
    }
    j.push(ht), T.push(me);
  }
  function f(m, J, j, T) {
    let k = [], x = 0, g = -1;
    for (; a.pos > J; ) {
      let { id: O, start: F, end: y, size: D } = a;
      if (D > 4)
        a.next();
      else {
        if (g > -1 && F < g)
          break;
        g < 0 && (g = y - i), k.push(O, F, y), x++, a.next();
      }
    }
    if (x) {
      let O = new Uint16Array(x * 4), F = k[k.length - 2];
      for (let y = k.length - 3, D = 0; y >= 0; y -= 3)
        O[D++] = k[y], O[D++] = k[y + 1] - F, O[D++] = k[y + 2] - F, O[D++] = D;
      j.push(new et(O, k[2] - F, s)), T.push(F - m);
    }
  }
  function p(m) {
    return (J, j, T) => {
      let k = 0, x = J.length - 1, g, O;
      if (x >= 0 && (g = J[x]) instanceof R) {
        if (!x && g.type == m && g.length == T)
          return g;
        (O = g.prop(b.lookAhead)) && (k = j[x] + g.length + O);
      }
      return S(m, J, j, T, k);
    };
  }
  function d(m, J, j, T, k, x, g, O) {
    let F = [], y = [];
    for (; m.length > T; )
      F.push(m.pop()), y.push(J.pop() + j - k);
    m.push(S(s.types[g], F, y, x - k, O - x)), J.push(k - j);
  }
  function S(m, J, j, T, k = 0, x) {
    if (h) {
      let g = [b.contextHash, h];
      x = x ? [g].concat(x) : [g];
    }
    if (k > 25) {
      let g = [b.lookAhead, k];
      x = x ? [g].concat(x) : [g];
    }
    return new R(m, J, j, T, x);
  }
  function w(m, J) {
    let j = a.fork(), T = 0, k = 0, x = 0, g = j.end - i, O = { size: 0, start: 0, skip: 0 };
    t:
      for (let F = j.pos - m; j.pos > F; ) {
        let y = j.size;
        if (j.id == J && y >= 0) {
          O.size = T, O.start = k, O.skip = x, x += 4, T += 4, j.next();
          continue;
        }
        let D = j.pos - y;
        if (y < 0 || D < F || j.start < g)
          break;
        let st = j.id >= o ? 4 : 0, ht = j.start;
        for (j.next(); j.pos > D; ) {
          if (j.size < 0)
            if (j.size == -3)
              st += 4;
            else
              break t;
          else
            j.id >= o && (st += 4);
          j.next();
        }
        k = ht, T += y, x += st;
      }
    return (J < 0 || T == m) && (O.size = T, O.start = k, O.skip = x), O.size > 4 ? O : void 0;
  }
  function z(m, J, j) {
    let { id: T, start: k, end: x, size: g } = a;
    if (a.next(), g >= 0 && T < o) {
      let O = j;
      if (g > 4) {
        let F = a.pos - (g - 4);
        for (; a.pos > F; )
          j = z(m, J, j);
      }
      J[--j] = O, J[--j] = x - m, J[--j] = k - m, J[--j] = T;
    } else
      g == -3 ? h = T : g == -4 && (u = T);
    return j;
  }
  let I = [], v = [];
  for (; a.pos > 0; )
    $(r.start || 0, r.bufferStart || 0, I, v, -1, 0);
  let E = (t = r.length) !== null && t !== void 0 ? t : I.length ? v[0] + I[0].length : 0;
  return new R(l[r.topID], I.reverse(), v.reverse(), E);
}
const Je = /* @__PURE__ */ new WeakMap();
function Vt(r, t) {
  if (!r.isAnonymous || t instanceof et || t.type != r)
    return 1;
  let e = Je.get(t);
  if (e == null) {
    e = 1;
    for (let s of t.children) {
      if (s.type != r || !(s instanceof R)) {
        e = 1;
        break;
      }
      e += Vt(r, s);
    }
    Je.set(t, e);
  }
  return e;
}
function je(r, t, e, s, i, n, o, a, l) {
  let h = 0;
  for (let d = s; d < i; d++)
    h += Vt(r, t[d]);
  let u = Math.ceil(
    h * 1.5 / 8
    /* Balance.BranchFactor */
  ), $ = [], f = [];
  function p(d, S, w, z, I) {
    for (let v = w; v < z; ) {
      let E = v, m = S[v], J = Vt(r, d[v]);
      for (v++; v < z; v++) {
        let j = Vt(r, d[v]);
        if (J + j >= u)
          break;
        J += j;
      }
      if (v == E + 1) {
        if (J > u) {
          let j = d[E];
          p(j.children, j.positions, 0, j.children.length, S[E] + I);
          continue;
        }
        $.push(d[E]);
      } else {
        let j = S[v - 1] + d[v - 1].length - m;
        $.push(je(r, d, S, E, v, m, j, null, l));
      }
      f.push(m + I - n);
    }
  }
  return p(t, e, s, i, 0), (a || l)($, f, o);
}
class lt {
  /**
  Construct a tree fragment. You'll usually want to use
  [`addTree`](#common.TreeFragment^addTree) and
  [`applyChanges`](#common.TreeFragment^applyChanges) instead of
  calling this directly.
  */
  constructor(t, e, s, i, n = !1, o = !1) {
    this.from = t, this.to = e, this.tree = s, this.offset = i, this.open = (n ? 1 : 0) | (o ? 2 : 0);
  }
  /**
  Whether the start of the fragment represents the start of a
  parse, or the end of a change. (In the second case, it may not
  be safe to reuse some nodes at the start, depending on the
  parsing algorithm.)
  */
  get openStart() {
    return (this.open & 1) > 0;
  }
  /**
  Whether the end of the fragment represents the end of a
  full-document parse, or the start of a change.
  */
  get openEnd() {
    return (this.open & 2) > 0;
  }
  /**
  Create a set of fragments from a freshly parsed tree, or update
  an existing set of fragments by replacing the ones that overlap
  with a tree with content from the new tree. When `partial` is
  true, the parse is treated as incomplete, and the resulting
  fragment has [`openEnd`](#common.TreeFragment.openEnd) set to
  true.
  */
  static addTree(t, e = [], s = !1) {
    let i = [new lt(0, t.length, t, 0, !1, s)];
    for (let n of e)
      n.to > t.length && i.push(n);
    return i;
  }
  /**
  Apply a set of edits to an array of fragments, removing or
  splitting fragments as necessary to remove edited ranges, and
  adjusting offsets for fragments that moved.
  */
  static applyChanges(t, e, s = 128) {
    if (!e.length)
      return t;
    let i = [], n = 1, o = t.length ? t[0] : null;
    for (let a = 0, l = 0, h = 0; ; a++) {
      let u = a < e.length ? e[a] : null, $ = u ? u.fromA : 1e9;
      if ($ - l >= s)
        for (; o && o.from < $; ) {
          let f = o;
          if (l >= f.from || $ <= f.to || h) {
            let p = Math.max(f.from, l) - h, d = Math.min(f.to, $) - h;
            f = p >= d ? null : new lt(p, d, f.tree, f.offset + h, a > 0, !!u);
          }
          if (f && i.push(f), o.to > $)
            break;
          o = n < t.length ? t[n++] : null;
        }
      if (!u)
        break;
      l = u.toA, h = u.toA - u.toB;
    }
    return i;
  }
}
class as {
  /**
  Start a parse, returning a [partial parse](#common.PartialParse)
  object. [`fragments`](#common.TreeFragment) can be passed in to
  make the parse incremental.
  
  By default, the entire input is parsed. You can pass `ranges`,
  which should be a sorted array of non-empty, non-overlapping
  ranges, to parse only those ranges. The tree returned in that
  case will start at `ranges[0].from`.
  */
  startParse(t, e, s) {
    return typeof t == "string" && (t = new Vs(t)), s = s ? s.length ? s.map((i) => new Qt(i.from, i.to)) : [new Qt(0, 0)] : [new Qt(0, t.length)], this.createParse(t, e || [], s);
  }
  /**
  Run a full parse, returning the resulting tree.
  */
  parse(t, e, s) {
    let i = this.startParse(t, e, s);
    for (; ; ) {
      let n = i.advance();
      if (n)
        return n;
    }
  }
}
class Vs {
  constructor(t) {
    this.string = t;
  }
  get length() {
    return this.string.length;
  }
  chunk(t) {
    return this.string.slice(t);
  }
  get lineChunks() {
    return !1;
  }
  read(t, e) {
    return this.string.slice(t, e);
  }
}
new b({ perNode: !0 });
class Wt {
  /**
  @internal
  */
  constructor(t, e, s, i, n, o, a, l, h, u = 0, $) {
    this.p = t, this.stack = e, this.state = s, this.reducePos = i, this.pos = n, this.score = o, this.buffer = a, this.bufferBase = l, this.curContext = h, this.lookAhead = u, this.parent = $;
  }
  /**
  @internal
  */
  toString() {
    return `[${this.stack.filter((t, e) => e % 3 == 0).concat(this.state)}]@${this.pos}${this.score ? "!" + this.score : ""}`;
  }
  // Start an empty stack
  /**
  @internal
  */
  static start(t, e, s = 0) {
    let i = t.parser.context;
    return new Wt(t, [], e, s, s, 0, [], 0, i ? new ye(i, i.start) : null, 0, null);
  }
  /**
  The stack's current [context](#lr.ContextTracker) value, if
  any. Its type will depend on the context tracker's type
  parameter, or it will be `null` if there is no context
  tracker.
  */
  get context() {
    return this.curContext ? this.curContext.context : null;
  }
  // Push a state onto the stack, tracking its start position as well
  // as the buffer base at that point.
  /**
  @internal
  */
  pushState(t, e) {
    this.stack.push(this.state, e, this.bufferBase + this.buffer.length), this.state = t;
  }
  // Apply a reduce action
  /**
  @internal
  */
  reduce(t) {
    var e;
    let s = t >> 19, i = t & 65535, { parser: n } = this.p, o = n.dynamicPrecedence(i);
    if (o && (this.score += o), s == 0) {
      this.pushState(n.getGoto(this.state, i, !0), this.reducePos), i < n.minRepeatTerm && this.storeNode(i, this.reducePos, this.reducePos, 4, !0), this.reduceContext(i, this.reducePos);
      return;
    }
    let a = this.stack.length - (s - 1) * 3 - (t & 262144 ? 6 : 0), l = a ? this.stack[a - 2] : this.p.ranges[0].from, h = this.reducePos - l;
    h >= 2e3 && !(!((e = this.p.parser.nodeSet.types[i]) === null || e === void 0) && e.isAnonymous) && (l == this.p.lastBigReductionStart ? (this.p.bigReductionCount++, this.p.lastBigReductionSize = h) : this.p.lastBigReductionSize < h && (this.p.bigReductionCount = 1, this.p.lastBigReductionStart = l, this.p.lastBigReductionSize = h));
    let u = a ? this.stack[a - 1] : 0, $ = this.bufferBase + this.buffer.length - u;
    if (i < n.minRepeatTerm || t & 131072) {
      let f = n.stateFlag(
        this.state,
        1
        /* StateFlag.Skipped */
      ) ? this.pos : this.reducePos;
      this.storeNode(i, l, f, $ + 4, !0);
    }
    if (t & 262144)
      this.state = this.stack[a];
    else {
      let f = this.stack[a - 3];
      this.state = n.getGoto(f, i, !0);
    }
    for (; this.stack.length > a; )
      this.stack.pop();
    this.reduceContext(i, l);
  }
  // Shift a value into the buffer
  /**
  @internal
  */
  storeNode(t, e, s, i = 4, n = !1) {
    if (t == 0 && (!this.stack.length || this.stack[this.stack.length - 1] < this.buffer.length + this.bufferBase)) {
      let o = this, a = this.buffer.length;
      if (a == 0 && o.parent && (a = o.bufferBase - o.parent.bufferBase, o = o.parent), a > 0 && o.buffer[a - 4] == 0 && o.buffer[a - 1] > -1) {
        if (e == s)
          return;
        if (o.buffer[a - 2] >= e) {
          o.buffer[a - 2] = s;
          return;
        }
      }
    }
    if (!n || this.pos == s)
      this.buffer.push(t, e, s, i);
    else {
      let o = this.buffer.length;
      if (o > 0 && this.buffer[o - 4] != 0)
        for (; o > 0 && this.buffer[o - 2] > s; )
          this.buffer[o] = this.buffer[o - 4], this.buffer[o + 1] = this.buffer[o - 3], this.buffer[o + 2] = this.buffer[o - 2], this.buffer[o + 3] = this.buffer[o - 1], o -= 4, i > 4 && (i -= 4);
      this.buffer[o] = t, this.buffer[o + 1] = e, this.buffer[o + 2] = s, this.buffer[o + 3] = i;
    }
  }
  // Apply a shift action
  /**
  @internal
  */
  shift(t, e, s, i) {
    if (t & 131072)
      this.pushState(t & 65535, this.pos);
    else if (t & 262144)
      this.pos = i, this.shiftContext(e, s), e <= this.p.parser.maxNode && this.buffer.push(e, s, i, 4);
    else {
      let n = t, { parser: o } = this.p;
      (i > this.pos || e <= o.maxNode) && (this.pos = i, o.stateFlag(
        n,
        1
        /* StateFlag.Skipped */
      ) || (this.reducePos = i)), this.pushState(n, s), this.shiftContext(e, s), e <= o.maxNode && this.buffer.push(e, s, i, 4);
    }
  }
  // Apply an action
  /**
  @internal
  */
  apply(t, e, s, i) {
    t & 65536 ? this.reduce(t) : this.shift(t, e, s, i);
  }
  // Add a prebuilt (reused) node into the buffer.
  /**
  @internal
  */
  useNode(t, e) {
    let s = this.p.reused.length - 1;
    (s < 0 || this.p.reused[s] != t) && (this.p.reused.push(t), s++);
    let i = this.pos;
    this.reducePos = this.pos = i + t.length, this.pushState(e, i), this.buffer.push(
      s,
      i,
      this.reducePos,
      -1
      /* size == -1 means this is a reused value */
    ), this.curContext && this.updateContext(this.curContext.tracker.reuse(this.curContext.context, t, this, this.p.stream.reset(this.pos - t.length)));
  }
  // Split the stack. Due to the buffer sharing and the fact
  // that `this.stack` tends to stay quite shallow, this isn't very
  // expensive.
  /**
  @internal
  */
  split() {
    let t = this, e = t.buffer.length;
    for (; e > 0 && t.buffer[e - 2] > t.reducePos; )
      e -= 4;
    let s = t.buffer.slice(e), i = t.bufferBase + e;
    for (; t && i == t.bufferBase; )
      t = t.parent;
    return new Wt(this.p, this.stack.slice(), this.state, this.reducePos, this.pos, this.score, s, i, this.curContext, this.lookAhead, t);
  }
  // Try to recover from an error by 'deleting' (ignoring) one token.
  /**
  @internal
  */
  recoverByDelete(t, e) {
    let s = t <= this.p.parser.maxNode;
    s && this.storeNode(t, this.pos, e, 4), this.storeNode(0, this.pos, e, s ? 8 : 4), this.pos = this.reducePos = e, this.score -= 190;
  }
  /**
  Check if the given term would be able to be shifted (optionally
  after some reductions) on this stack. This can be useful for
  external tokenizers that want to make sure they only provide a
  given token when it applies.
  */
  canShift(t) {
    for (let e = new Is(this); ; ) {
      let s = this.p.parser.stateSlot(
        e.state,
        4
        /* ParseState.DefaultReduce */
      ) || this.p.parser.hasAction(e.state, t);
      if (s == 0)
        return !1;
      if (!(s & 65536))
        return !0;
      e.reduce(s);
    }
  }
  // Apply up to Recover.MaxNext recovery actions that conceptually
  // inserts some missing token or rule.
  /**
  @internal
  */
  recoverByInsert(t) {
    if (this.stack.length >= 300)
      return [];
    let e = this.p.parser.nextStates(this.state);
    if (e.length > 8 || this.stack.length >= 120) {
      let i = [];
      for (let n = 0, o; n < e.length; n += 2)
        (o = e[n + 1]) != this.state && this.p.parser.hasAction(o, t) && i.push(e[n], o);
      if (this.stack.length < 120)
        for (let n = 0; i.length < 8 && n < e.length; n += 2) {
          let o = e[n + 1];
          i.some((a, l) => l & 1 && a == o) || i.push(e[n], o);
        }
      e = i;
    }
    let s = [];
    for (let i = 0; i < e.length && s.length < 4; i += 2) {
      let n = e[i + 1];
      if (n == this.state)
        continue;
      let o = this.split();
      o.pushState(n, this.pos), o.storeNode(0, o.pos, o.pos, 4, !0), o.shiftContext(e[i], this.pos), o.reducePos = this.pos, o.score -= 200, s.push(o);
    }
    return s;
  }
  // Force a reduce, if possible. Return false if that can't
  // be done.
  /**
  @internal
  */
  forceReduce() {
    let { parser: t } = this.p, e = t.stateSlot(
      this.state,
      5
      /* ParseState.ForcedReduce */
    );
    if (!(e & 65536))
      return !1;
    if (!t.validAction(this.state, e)) {
      let s = e >> 19, i = e & 65535, n = this.stack.length - s * 3;
      if (n < 0 || t.getGoto(this.stack[n], i, !1) < 0) {
        let o = this.findForcedReduction();
        if (o == null)
          return !1;
        e = o;
      }
      this.storeNode(0, this.pos, this.pos, 4, !0), this.score -= 100;
    }
    return this.reducePos = this.pos, this.reduce(e), !0;
  }
  /**
  Try to scan through the automaton to find some kind of reduction
  that can be applied. Used when the regular ForcedReduce field
  isn't a valid action. @internal
  */
  findForcedReduction() {
    let { parser: t } = this.p, e = [], s = (i, n) => {
      if (!e.includes(i))
        return e.push(i), t.allActions(i, (o) => {
          if (!(o & 393216))
            if (o & 65536) {
              let a = (o >> 19) - n;
              if (a > 1) {
                let l = o & 65535, h = this.stack.length - a * 3;
                if (h >= 0 && t.getGoto(this.stack[h], l, !1) >= 0)
                  return a << 19 | 65536 | l;
              }
            } else {
              let a = s(o, n + 1);
              if (a != null)
                return a;
            }
        });
    };
    return s(this.state, 0);
  }
  /**
  @internal
  */
  forceAll() {
    for (; !this.p.parser.stateFlag(
      this.state,
      2
      /* StateFlag.Accepting */
    ); )
      if (!this.forceReduce()) {
        this.storeNode(0, this.pos, this.pos, 4, !0);
        break;
      }
    return this;
  }
  /**
  Check whether this state has no further actions (assumed to be a direct descendant of the
  top state, since any other states must be able to continue
  somehow). @internal
  */
  get deadEnd() {
    if (this.stack.length != 3)
      return !1;
    let { parser: t } = this.p;
    return t.data[t.stateSlot(
      this.state,
      1
      /* ParseState.Actions */
    )] == 65535 && !t.stateSlot(
      this.state,
      4
      /* ParseState.DefaultReduce */
    );
  }
  /**
  Restart the stack (put it back in its start state). Only safe
  when this.stack.length == 3 (state is directly below the top
  state). @internal
  */
  restart() {
    this.storeNode(0, this.pos, this.pos, 4, !0), this.state = this.stack[0], this.stack.length = 0;
  }
  /**
  @internal
  */
  sameState(t) {
    if (this.state != t.state || this.stack.length != t.stack.length)
      return !1;
    for (let e = 0; e < this.stack.length; e += 3)
      if (this.stack[e] != t.stack[e])
        return !1;
    return !0;
  }
  /**
  Get the parser used by this stack.
  */
  get parser() {
    return this.p.parser;
  }
  /**
  Test whether a given dialect (by numeric ID, as exported from
  the terms file) is enabled.
  */
  dialectEnabled(t) {
    return this.p.parser.dialect.flags[t];
  }
  shiftContext(t, e) {
    this.curContext && this.updateContext(this.curContext.tracker.shift(this.curContext.context, t, this, this.p.stream.reset(e)));
  }
  reduceContext(t, e) {
    this.curContext && this.updateContext(this.curContext.tracker.reduce(this.curContext.context, t, this, this.p.stream.reset(e)));
  }
  /**
  @internal
  */
  emitContext() {
    let t = this.buffer.length - 1;
    (t < 0 || this.buffer[t] != -3) && this.buffer.push(this.curContext.hash, this.pos, this.pos, -3);
  }
  /**
  @internal
  */
  emitLookAhead() {
    let t = this.buffer.length - 1;
    (t < 0 || this.buffer[t] != -4) && this.buffer.push(this.lookAhead, this.pos, this.pos, -4);
  }
  updateContext(t) {
    if (t != this.curContext.context) {
      let e = new ye(this.curContext.tracker, t);
      e.hash != this.curContext.hash && this.emitContext(), this.curContext = e;
    }
  }
  /**
  @internal
  */
  setLookAhead(t) {
    t > this.lookAhead && (this.emitLookAhead(), this.lookAhead = t);
  }
  /**
  @internal
  */
  close() {
    this.curContext && this.curContext.tracker.strict && this.emitContext(), this.lookAhead > 0 && this.emitLookAhead();
  }
}
class ye {
  constructor(t, e) {
    this.tracker = t, this.context = e, this.hash = t.strict ? t.hash(e) : 0;
  }
}
class Is {
  constructor(t) {
    this.start = t, this.state = t.state, this.stack = t.stack, this.base = this.stack.length;
  }
  reduce(t) {
    let e = t & 65535, s = t >> 19;
    s == 0 ? (this.stack == this.start.stack && (this.stack = this.stack.slice()), this.stack.push(this.state, 0, 0), this.base += 3) : this.base -= (s - 1) * 3;
    let i = this.start.p.parser.getGoto(this.stack[this.base - 3], e, !0);
    this.state = i;
  }
}
class Pt {
  constructor(t, e, s) {
    this.stack = t, this.pos = e, this.index = s, this.buffer = t.buffer, this.index == 0 && this.maybeNext();
  }
  static create(t, e = t.bufferBase + t.buffer.length) {
    return new Pt(t, e, e - t.bufferBase);
  }
  maybeNext() {
    let t = this.stack.parent;
    t != null && (this.index = this.stack.bufferBase - t.bufferBase, this.stack = t, this.buffer = t.buffer);
  }
  get id() {
    return this.buffer[this.index - 4];
  }
  get start() {
    return this.buffer[this.index - 3];
  }
  get end() {
    return this.buffer[this.index - 2];
  }
  get size() {
    return this.buffer[this.index - 1];
  }
  next() {
    this.index -= 4, this.pos -= 4, this.index == 0 && this.maybeNext();
  }
  fork() {
    return new Pt(this.stack, this.pos, this.index);
  }
}
function Jt(r, t = Uint16Array) {
  if (typeof r != "string")
    return r;
  let e = null;
  for (let s = 0, i = 0; s < r.length; ) {
    let n = 0;
    for (; ; ) {
      let o = r.charCodeAt(s++), a = !1;
      if (o == 126) {
        n = 65535;
        break;
      }
      o >= 92 && o--, o >= 34 && o--;
      let l = o - 32;
      if (l >= 46 && (l -= 46, a = !0), n += l, a)
        break;
      n *= 46;
    }
    e ? e[i++] = n : e = new t(n);
  }
  return e;
}
class It {
  constructor() {
    this.start = -1, this.value = -1, this.end = -1, this.extended = -1, this.lookAhead = 0, this.mask = 0, this.context = 0;
  }
}
const we = new It();
class zs {
  /**
  @internal
  */
  constructor(t, e) {
    this.input = t, this.ranges = e, this.chunk = "", this.chunkOff = 0, this.chunk2 = "", this.chunk2Pos = 0, this.next = -1, this.token = we, this.rangeIndex = 0, this.pos = this.chunkPos = e[0].from, this.range = e[0], this.end = e[e.length - 1].to, this.readNext();
  }
  /**
  @internal
  */
  resolveOffset(t, e) {
    let s = this.range, i = this.rangeIndex, n = this.pos + t;
    for (; n < s.from; ) {
      if (!i)
        return null;
      let o = this.ranges[--i];
      n -= s.from - o.to, s = o;
    }
    for (; e < 0 ? n > s.to : n >= s.to; ) {
      if (i == this.ranges.length - 1)
        return null;
      let o = this.ranges[++i];
      n += o.from - s.to, s = o;
    }
    return n;
  }
  /**
  @internal
  */
  clipPos(t) {
    if (t >= this.range.from && t < this.range.to)
      return t;
    for (let e of this.ranges)
      if (e.to > t)
        return Math.max(t, e.from);
    return this.end;
  }
  /**
  Look at a code unit near the stream position. `.peek(0)` equals
  `.next`, `.peek(-1)` gives you the previous character, and so
  on.
  
  Note that looking around during tokenizing creates dependencies
  on potentially far-away content, which may reduce the
  effectiveness incremental parsing—when looking forward—or even
  cause invalid reparses when looking backward more than 25 code
  units, since the library does not track lookbehind.
  */
  peek(t) {
    let e = this.chunkOff + t, s, i;
    if (e >= 0 && e < this.chunk.length)
      s = this.pos + t, i = this.chunk.charCodeAt(e);
    else {
      let n = this.resolveOffset(t, 1);
      if (n == null)
        return -1;
      if (s = n, s >= this.chunk2Pos && s < this.chunk2Pos + this.chunk2.length)
        i = this.chunk2.charCodeAt(s - this.chunk2Pos);
      else {
        let o = this.rangeIndex, a = this.range;
        for (; a.to <= s; )
          a = this.ranges[++o];
        this.chunk2 = this.input.chunk(this.chunk2Pos = s), s + this.chunk2.length > a.to && (this.chunk2 = this.chunk2.slice(0, a.to - s)), i = this.chunk2.charCodeAt(0);
      }
    }
    return s >= this.token.lookAhead && (this.token.lookAhead = s + 1), i;
  }
  /**
  Accept a token. By default, the end of the token is set to the
  current stream position, but you can pass an offset (relative to
  the stream position) to change that.
  */
  acceptToken(t, e = 0) {
    let s = e ? this.resolveOffset(e, -1) : this.pos;
    if (s == null || s < this.token.start)
      throw new RangeError("Token end out of bounds");
    this.token.value = t, this.token.end = s;
  }
  getChunk() {
    if (this.pos >= this.chunk2Pos && this.pos < this.chunk2Pos + this.chunk2.length) {
      let { chunk: t, chunkPos: e } = this;
      this.chunk = this.chunk2, this.chunkPos = this.chunk2Pos, this.chunk2 = t, this.chunk2Pos = e, this.chunkOff = this.pos - this.chunkPos;
    } else {
      this.chunk2 = this.chunk, this.chunk2Pos = this.chunkPos;
      let t = this.input.chunk(this.pos), e = this.pos + t.length;
      this.chunk = e > this.range.to ? t.slice(0, this.range.to - this.pos) : t, this.chunkPos = this.pos, this.chunkOff = 0;
    }
  }
  readNext() {
    return this.chunkOff >= this.chunk.length && (this.getChunk(), this.chunkOff == this.chunk.length) ? this.next = -1 : this.next = this.chunk.charCodeAt(this.chunkOff);
  }
  /**
  Move the stream forward N (defaults to 1) code units. Returns
  the new value of [`next`](#lr.InputStream.next).
  */
  advance(t = 1) {
    for (this.chunkOff += t; this.pos + t >= this.range.to; ) {
      if (this.rangeIndex == this.ranges.length - 1)
        return this.setDone();
      t -= this.range.to - this.pos, this.range = this.ranges[++this.rangeIndex], this.pos = this.range.from;
    }
    return this.pos += t, this.pos >= this.token.lookAhead && (this.token.lookAhead = this.pos + 1), this.readNext();
  }
  setDone() {
    return this.pos = this.chunkPos = this.end, this.range = this.ranges[this.rangeIndex = this.ranges.length - 1], this.chunk = "", this.next = -1;
  }
  /**
  @internal
  */
  reset(t, e) {
    if (e ? (this.token = e, e.start = t, e.lookAhead = t + 1, e.value = e.extended = -1) : this.token = we, this.pos != t) {
      if (this.pos = t, t == this.end)
        return this.setDone(), this;
      for (; t < this.range.from; )
        this.range = this.ranges[--this.rangeIndex];
      for (; t >= this.range.to; )
        this.range = this.ranges[++this.rangeIndex];
      t >= this.chunkPos && t < this.chunkPos + this.chunk.length ? this.chunkOff = t - this.chunkPos : (this.chunk = "", this.chunkOff = 0), this.readNext();
    }
    return this;
  }
  /**
  @internal
  */
  read(t, e) {
    if (t >= this.chunkPos && e <= this.chunkPos + this.chunk.length)
      return this.chunk.slice(t - this.chunkPos, e - this.chunkPos);
    if (t >= this.chunk2Pos && e <= this.chunk2Pos + this.chunk2.length)
      return this.chunk2.slice(t - this.chunk2Pos, e - this.chunk2Pos);
    if (t >= this.range.from && e <= this.range.to)
      return this.input.read(t, e);
    let s = "";
    for (let i of this.ranges) {
      if (i.from >= e)
        break;
      i.to > t && (s += this.input.read(Math.max(i.from, t), Math.min(i.to, e)));
    }
    return s;
  }
}
class ct {
  constructor(t, e) {
    this.data = t, this.id = e;
  }
  token(t, e) {
    let { parser: s } = e.p;
    Ds(this.data, t, e, this.id, s.data, s.tokenPrecTable);
  }
}
ct.prototype.contextual = ct.prototype.fallback = ct.prototype.extend = !1;
ct.prototype.fallback = ct.prototype.extend = !1;
class ls {
  /**
  Create a tokenizer. The first argument is the function that,
  given an input stream, scans for the types of tokens it
  recognizes at the stream's position, and calls
  [`acceptToken`](#lr.InputStream.acceptToken) when it finds
  one.
  */
  constructor(t, e = {}) {
    this.token = t, this.contextual = !!e.contextual, this.fallback = !!e.fallback, this.extend = !!e.extend;
  }
}
function Ds(r, t, e, s, i, n) {
  let o = 0, a = 1 << s, { dialect: l } = e.p.parser;
  t:
    for (; a & r[o]; ) {
      let h = r[o + 1];
      for (let p = o + 3; p < h; p += 2)
        if ((r[p + 1] & a) > 0) {
          let d = r[p];
          if (l.allows(d) && (t.token.value == -1 || t.token.value == d || Ws(d, t.token.value, i, n))) {
            t.acceptToken(d);
            break;
          }
        }
      let u = t.next, $ = 0, f = r[o + 2];
      if (t.next < 0 && f > $ && r[h + f * 3 - 3] == 65535) {
        o = r[h + f * 3 - 1];
        continue t;
      }
      for (; $ < f; ) {
        let p = $ + f >> 1, d = h + p + (p << 1), S = r[d], w = r[d + 1] || 65536;
        if (u < S)
          f = p;
        else if (u >= w)
          $ = p + 1;
        else {
          o = r[d + 2], t.advance();
          continue t;
        }
      }
      break;
    }
}
function Te(r, t, e) {
  for (let s = t, i; (i = r[s]) != 65535; s++)
    if (i == e)
      return s - t;
  return -1;
}
function Ws(r, t, e, s) {
  let i = Te(e, s, t);
  return i < 0 || Te(e, s, r) < i;
}
const P = typeof process < "u" && process.env && /\bparse\b/.test(process.env.LOG);
let Kt = null;
function Fe(r, t, e) {
  let s = r.cursor(V.IncludeAnonymous);
  for (s.moveTo(t); ; )
    if (!(e < 0 ? s.childBefore(t) : s.childAfter(t)))
      for (; ; ) {
        if ((e < 0 ? s.to < t : s.from > t) && !s.type.isError)
          return e < 0 ? Math.max(0, Math.min(
            s.to - 1,
            t - 25
            /* Safety.Margin */
          )) : Math.min(r.length, Math.max(
            s.from + 1,
            t + 25
            /* Safety.Margin */
          ));
        if (e < 0 ? s.prevSibling() : s.nextSibling())
          break;
        if (!s.parent())
          return e < 0 ? 0 : r.length;
      }
}
class Ps {
  constructor(t, e) {
    this.fragments = t, this.nodeSet = e, this.i = 0, this.fragment = null, this.safeFrom = -1, this.safeTo = -1, this.trees = [], this.start = [], this.index = [], this.nextFragment();
  }
  nextFragment() {
    let t = this.fragment = this.i == this.fragments.length ? null : this.fragments[this.i++];
    if (t) {
      for (this.safeFrom = t.openStart ? Fe(t.tree, t.from + t.offset, 1) - t.offset : t.from, this.safeTo = t.openEnd ? Fe(t.tree, t.to + t.offset, -1) - t.offset : t.to; this.trees.length; )
        this.trees.pop(), this.start.pop(), this.index.pop();
      this.trees.push(t.tree), this.start.push(-t.offset), this.index.push(0), this.nextStart = this.safeFrom;
    } else
      this.nextStart = 1e9;
  }
  // `pos` must be >= any previously given `pos` for this cursor
  nodeAt(t) {
    if (t < this.nextStart)
      return null;
    for (; this.fragment && this.safeTo <= t; )
      this.nextFragment();
    if (!this.fragment)
      return null;
    for (; ; ) {
      let e = this.trees.length - 1;
      if (e < 0)
        return this.nextFragment(), null;
      let s = this.trees[e], i = this.index[e];
      if (i == s.children.length) {
        this.trees.pop(), this.start.pop(), this.index.pop();
        continue;
      }
      let n = s.children[i], o = this.start[e] + s.positions[i];
      if (o > t)
        return this.nextStart = o, null;
      if (n instanceof R) {
        if (o == t) {
          if (o < this.safeFrom)
            return null;
          let a = o + n.length;
          if (a <= this.safeTo) {
            let l = n.prop(b.lookAhead);
            if (!l || a + l < this.fragment.to)
              return n;
          }
        }
        this.index[e]++, o + n.length >= Math.max(this.safeFrom, t) && (this.trees.push(n), this.start.push(o), this.index.push(0));
      } else
        this.index[e]++, this.nextStart = o + n.length;
    }
  }
}
class Cs {
  constructor(t, e) {
    this.stream = e, this.tokens = [], this.mainToken = null, this.actions = [], this.tokens = t.tokenizers.map((s) => new It());
  }
  getActions(t) {
    let e = 0, s = null, { parser: i } = t.p, { tokenizers: n } = i, o = i.stateSlot(
      t.state,
      3
      /* ParseState.TokenizerMask */
    ), a = t.curContext ? t.curContext.hash : 0, l = 0;
    for (let h = 0; h < n.length; h++) {
      if (!(1 << h & o))
        continue;
      let u = n[h], $ = this.tokens[h];
      if (!(s && !u.fallback) && ((u.contextual || $.start != t.pos || $.mask != o || $.context != a) && (this.updateCachedToken($, u, t), $.mask = o, $.context = a), $.lookAhead > $.end + 25 && (l = Math.max($.lookAhead, l)), $.value != 0)) {
        let f = e;
        if ($.extended > -1 && (e = this.addActions(t, $.extended, $.end, e)), e = this.addActions(t, $.value, $.end, e), !u.extend && (s = $, e > f))
          break;
      }
    }
    for (; this.actions.length > e; )
      this.actions.pop();
    return l && t.setLookAhead(l), !s && t.pos == this.stream.end && (s = new It(), s.value = t.p.parser.eofTerm, s.start = s.end = t.pos, e = this.addActions(t, s.value, s.end, e)), this.mainToken = s, this.actions;
  }
  getMainToken(t) {
    if (this.mainToken)
      return this.mainToken;
    let e = new It(), { pos: s, p: i } = t;
    return e.start = s, e.end = Math.min(s + 1, i.stream.end), e.value = s == i.stream.end ? i.parser.eofTerm : 0, e;
  }
  updateCachedToken(t, e, s) {
    let i = this.stream.clipPos(s.pos);
    if (e.token(this.stream.reset(i, t), s), t.value > -1) {
      let { parser: n } = s.p;
      for (let o = 0; o < n.specialized.length; o++)
        if (n.specialized[o] == t.value) {
          let a = n.specializers[o](this.stream.read(t.start, t.end), s);
          if (a >= 0 && s.p.parser.dialect.allows(a >> 1)) {
            a & 1 ? t.extended = a >> 1 : t.value = a >> 1;
            break;
          }
        }
    } else
      t.value = 0, t.end = this.stream.clipPos(i + 1);
  }
  putAction(t, e, s, i) {
    for (let n = 0; n < i; n += 3)
      if (this.actions[n] == t)
        return i;
    return this.actions[i++] = t, this.actions[i++] = e, this.actions[i++] = s, i;
  }
  addActions(t, e, s, i) {
    let { state: n } = t, { parser: o } = t.p, { data: a } = o;
    for (let l = 0; l < 2; l++)
      for (let h = o.stateSlot(
        n,
        l ? 2 : 1
        /* ParseState.Actions */
      ); ; h += 3) {
        if (a[h] == 65535)
          if (a[h + 1] == 1)
            h = Z(a, h + 2);
          else {
            i == 0 && a[h + 1] == 2 && (i = this.putAction(Z(a, h + 2), e, s, i));
            break;
          }
        a[h] == e && (i = this.putAction(Z(a, h + 1), e, s, i));
      }
    return i;
  }
}
class qs {
  constructor(t, e, s, i) {
    this.parser = t, this.input = e, this.ranges = i, this.recovering = 0, this.nextStackID = 9812, this.minStackPos = 0, this.reused = [], this.stoppedAt = null, this.lastBigReductionStart = -1, this.lastBigReductionSize = 0, this.bigReductionCount = 0, this.stream = new zs(e, i), this.tokens = new Cs(t, this.stream), this.topTerm = t.top[1];
    let { from: n } = i[0];
    this.stacks = [Wt.start(this, t.top[0], n)], this.fragments = s.length && this.stream.end - n > t.bufferLength * 4 ? new Ps(s, t.nodeSet) : null;
  }
  get parsedPos() {
    return this.minStackPos;
  }
  // Move the parser forward. This will process all parse stacks at
  // `this.pos` and try to advance them to a further position. If no
  // stack for such a position is found, it'll start error-recovery.
  //
  // When the parse is finished, this will return a syntax tree. When
  // not, it returns `null`.
  advance() {
    let t = this.stacks, e = this.minStackPos, s = this.stacks = [], i, n;
    if (this.bigReductionCount > 300 && t.length == 1) {
      let [o] = t;
      for (; o.forceReduce() && o.stack.length && o.stack[o.stack.length - 2] >= this.lastBigReductionStart; )
        ;
      this.bigReductionCount = this.lastBigReductionSize = 0;
    }
    for (let o = 0; o < t.length; o++) {
      let a = t[o];
      for (; ; ) {
        if (this.tokens.mainToken = null, a.pos > e)
          s.push(a);
        else {
          if (this.advanceStack(a, s, t))
            continue;
          {
            i || (i = [], n = []), i.push(a);
            let l = this.tokens.getMainToken(a);
            n.push(l.value, l.end);
          }
        }
        break;
      }
    }
    if (!s.length) {
      let o = i && Es(i);
      if (o)
        return P && console.log("Finish with " + this.stackID(o)), this.stackToTree(o);
      if (this.parser.strict)
        throw P && i && console.log("Stuck with token " + (this.tokens.mainToken ? this.parser.getName(this.tokens.mainToken.value) : "none")), new SyntaxError("No parse at " + e);
      this.recovering || (this.recovering = 5);
    }
    if (this.recovering && i) {
      let o = this.stoppedAt != null && i[0].pos > this.stoppedAt ? i[0] : this.runRecovery(i, n, s);
      if (o)
        return P && console.log("Force-finish " + this.stackID(o)), this.stackToTree(o.forceAll());
    }
    if (this.recovering) {
      let o = this.recovering == 1 ? 1 : this.recovering * 3;
      if (s.length > o)
        for (s.sort((a, l) => l.score - a.score); s.length > o; )
          s.pop();
      s.some((a) => a.reducePos > e) && this.recovering--;
    } else if (s.length > 1) {
      t:
        for (let o = 0; o < s.length - 1; o++) {
          let a = s[o];
          for (let l = o + 1; l < s.length; l++) {
            let h = s[l];
            if (a.sameState(h) || a.buffer.length > 500 && h.buffer.length > 500)
              if ((a.score - h.score || a.buffer.length - h.buffer.length) > 0)
                s.splice(l--, 1);
              else {
                s.splice(o--, 1);
                continue t;
              }
          }
        }
      s.length > 12 && s.splice(
        12,
        s.length - 12
        /* Rec.MaxStackCount */
      );
    }
    this.minStackPos = s[0].pos;
    for (let o = 1; o < s.length; o++)
      s[o].pos < this.minStackPos && (this.minStackPos = s[o].pos);
    return null;
  }
  stopAt(t) {
    if (this.stoppedAt != null && this.stoppedAt < t)
      throw new RangeError("Can't move stoppedAt forward");
    this.stoppedAt = t;
  }
  // Returns an updated version of the given stack, or null if the
  // stack can't advance normally. When `split` and `stacks` are
  // given, stacks split off by ambiguous operations will be pushed to
  // `split`, or added to `stacks` if they move `pos` forward.
  advanceStack(t, e, s) {
    let i = t.pos, { parser: n } = this, o = P ? this.stackID(t) + " -> " : "";
    if (this.stoppedAt != null && i > this.stoppedAt)
      return t.forceReduce() ? t : null;
    if (this.fragments) {
      let h = t.curContext && t.curContext.tracker.strict, u = h ? t.curContext.hash : 0;
      for (let $ = this.fragments.nodeAt(i); $; ) {
        let f = this.parser.nodeSet.types[$.type.id] == $.type ? n.getGoto(t.state, $.type.id) : -1;
        if (f > -1 && $.length && (!h || ($.prop(b.contextHash) || 0) == u))
          return t.useNode($, f), P && console.log(o + this.stackID(t) + ` (via reuse of ${n.getName($.type.id)})`), !0;
        if (!($ instanceof R) || $.children.length == 0 || $.positions[0] > 0)
          break;
        let p = $.children[0];
        if (p instanceof R && $.positions[0] == 0)
          $ = p;
        else
          break;
      }
    }
    let a = n.stateSlot(
      t.state,
      4
      /* ParseState.DefaultReduce */
    );
    if (a > 0)
      return t.reduce(a), P && console.log(o + this.stackID(t) + ` (via always-reduce ${n.getName(
        a & 65535
        /* Action.ValueMask */
      )})`), !0;
    if (t.stack.length >= 8400)
      for (; t.stack.length > 6e3 && t.forceReduce(); )
        ;
    let l = this.tokens.getActions(t);
    for (let h = 0; h < l.length; ) {
      let u = l[h++], $ = l[h++], f = l[h++], p = h == l.length || !s, d = p ? t : t.split(), S = this.tokens.mainToken;
      if (d.apply(u, $, S ? S.start : d.pos, f), P && console.log(o + this.stackID(d) + ` (via ${u & 65536 ? `reduce of ${n.getName(
        u & 65535
        /* Action.ValueMask */
      )}` : "shift"} for ${n.getName($)} @ ${i}${d == t ? "" : ", split"})`), p)
        return !0;
      d.pos > i ? e.push(d) : s.push(d);
    }
    return !1;
  }
  // Advance a given stack forward as far as it will go. Returns the
  // (possibly updated) stack if it got stuck, or null if it moved
  // forward and was given to `pushStackDedup`.
  advanceFully(t, e) {
    let s = t.pos;
    for (; ; ) {
      if (!this.advanceStack(t, null, null))
        return !1;
      if (t.pos > s)
        return ve(t, e), !0;
    }
  }
  runRecovery(t, e, s) {
    let i = null, n = !1;
    for (let o = 0; o < t.length; o++) {
      let a = t[o], l = e[o << 1], h = e[(o << 1) + 1], u = P ? this.stackID(a) + " -> " : "";
      if (a.deadEnd && (n || (n = !0, a.restart(), P && console.log(u + this.stackID(a) + " (restarted)"), this.advanceFully(a, s))))
        continue;
      let $ = a.split(), f = u;
      for (let p = 0; $.forceReduce() && p < 10 && (P && console.log(f + this.stackID($) + " (via force-reduce)"), !this.advanceFully($, s)); p++)
        P && (f = this.stackID($) + " -> ");
      for (let p of a.recoverByInsert(l))
        P && console.log(u + this.stackID(p) + " (via recover-insert)"), this.advanceFully(p, s);
      this.stream.end > a.pos ? (h == a.pos && (h++, l = 0), a.recoverByDelete(l, h), P && console.log(u + this.stackID(a) + ` (via recover-delete ${this.parser.getName(l)})`), ve(a, s)) : (!i || i.score < a.score) && (i = a);
    }
    return i;
  }
  // Convert the stack's buffer to a syntax tree.
  stackToTree(t) {
    return t.close(), R.build({
      buffer: Pt.create(t),
      nodeSet: this.parser.nodeSet,
      topID: this.topTerm,
      maxBufferLength: this.parser.bufferLength,
      reused: this.reused,
      start: this.ranges[0].from,
      length: t.pos - this.ranges[0].from,
      minRepeatType: this.parser.minRepeatTerm
    });
  }
  stackID(t) {
    let e = (Kt || (Kt = /* @__PURE__ */ new WeakMap())).get(t);
    return e || Kt.set(t, e = String.fromCodePoint(this.nextStackID++)), e + t;
  }
}
function ve(r, t) {
  for (let e = 0; e < t.length; e++) {
    let s = t[e];
    if (s.pos == r.pos && s.sameState(r)) {
      t[e].score < r.score && (t[e] = r);
      return;
    }
  }
  t.push(r);
}
class Ns {
  constructor(t, e, s) {
    this.source = t, this.flags = e, this.disabled = s;
  }
  allows(t) {
    return !this.disabled || this.disabled[t] == 0;
  }
}
class Ct extends as {
  /**
  @internal
  */
  constructor(t) {
    if (super(), this.wrappers = [], t.version != 14)
      throw new RangeError(`Parser version (${t.version}) doesn't match runtime version (14)`);
    let e = t.nodeNames.split(" ");
    this.minRepeatTerm = e.length;
    for (let a = 0; a < t.repeatNodeCount; a++)
      e.push("");
    let s = Object.keys(t.topRules).map((a) => t.topRules[a][1]), i = [];
    for (let a = 0; a < e.length; a++)
      i.push([]);
    function n(a, l, h) {
      i[a].push([l, l.deserialize(String(h))]);
    }
    if (t.nodeProps)
      for (let a of t.nodeProps) {
        let l = a[0];
        typeof l == "string" && (l = b[l]);
        for (let h = 1; h < a.length; ) {
          let u = a[h++];
          if (u >= 0)
            n(u, l, a[h++]);
          else {
            let $ = a[h + -u];
            for (let f = -u; f > 0; f--)
              n(a[h++], l, $);
            h++;
          }
        }
      }
    this.nodeSet = new pe(e.map((a, l) => W.define({
      name: l >= this.minRepeatTerm ? void 0 : a,
      id: l,
      props: i[l],
      top: s.indexOf(l) > -1,
      error: l == 0,
      skipped: t.skippedNodes && t.skippedNodes.indexOf(l) > -1
    }))), t.propSources && (this.nodeSet = this.nodeSet.extend(...t.propSources)), this.strict = !1, this.bufferLength = is;
    let o = Jt(t.tokenData);
    this.context = t.context, this.specializerSpecs = t.specialized || [], this.specialized = new Uint16Array(this.specializerSpecs.length);
    for (let a = 0; a < this.specializerSpecs.length; a++)
      this.specialized[a] = this.specializerSpecs[a].term;
    this.specializers = this.specializerSpecs.map(Re), this.states = Jt(t.states, Uint32Array), this.data = Jt(t.stateData), this.goto = Jt(t.goto), this.maxTerm = t.maxTerm, this.tokenizers = t.tokenizers.map((a) => typeof a == "number" ? new ct(o, a) : a), this.topRules = t.topRules, this.dialects = t.dialects || {}, this.dynamicPrecedences = t.dynamicPrecedences || null, this.tokenPrecTable = t.tokenPrec, this.termNames = t.termNames || null, this.maxNode = this.nodeSet.types.length - 1, this.dialect = this.parseDialect(), this.top = this.topRules[Object.keys(this.topRules)[0]];
  }
  createParse(t, e, s) {
    let i = new qs(this, t, e, s);
    for (let n of this.wrappers)
      i = n(i, t, e, s);
    return i;
  }
  /**
  Get a goto table entry @internal
  */
  getGoto(t, e, s = !1) {
    let i = this.goto;
    if (e >= i[0])
      return -1;
    for (let n = i[e + 1]; ; ) {
      let o = i[n++], a = o & 1, l = i[n++];
      if (a && s)
        return l;
      for (let h = n + (o >> 1); n < h; n++)
        if (i[n] == t)
          return l;
      if (a)
        return -1;
    }
  }
  /**
  Check if this state has an action for a given terminal @internal
  */
  hasAction(t, e) {
    let s = this.data;
    for (let i = 0; i < 2; i++)
      for (let n = this.stateSlot(
        t,
        i ? 2 : 1
        /* ParseState.Actions */
      ), o; ; n += 3) {
        if ((o = s[n]) == 65535)
          if (s[n + 1] == 1)
            o = s[n = Z(s, n + 2)];
          else {
            if (s[n + 1] == 2)
              return Z(s, n + 2);
            break;
          }
        if (o == e || o == 0)
          return Z(s, n + 1);
      }
    return 0;
  }
  /**
  @internal
  */
  stateSlot(t, e) {
    return this.states[t * 6 + e];
  }
  /**
  @internal
  */
  stateFlag(t, e) {
    return (this.stateSlot(
      t,
      0
      /* ParseState.Flags */
    ) & e) > 0;
  }
  /**
  @internal
  */
  validAction(t, e) {
    return !!this.allActions(t, (s) => s == e ? !0 : null);
  }
  /**
  @internal
  */
  allActions(t, e) {
    let s = this.stateSlot(
      t,
      4
      /* ParseState.DefaultReduce */
    ), i = s ? e(s) : void 0;
    for (let n = this.stateSlot(
      t,
      1
      /* ParseState.Actions */
    ); i == null; n += 3) {
      if (this.data[n] == 65535)
        if (this.data[n + 1] == 1)
          n = Z(this.data, n + 2);
        else
          break;
      i = e(Z(this.data, n + 1));
    }
    return i;
  }
  /**
  Get the states that can follow this one through shift actions or
  goto jumps. @internal
  */
  nextStates(t) {
    let e = [];
    for (let s = this.stateSlot(
      t,
      1
      /* ParseState.Actions */
    ); ; s += 3) {
      if (this.data[s] == 65535)
        if (this.data[s + 1] == 1)
          s = Z(this.data, s + 2);
        else
          break;
      if (!(this.data[s + 2] & 1)) {
        let i = this.data[s + 1];
        e.some((n, o) => o & 1 && n == i) || e.push(this.data[s], i);
      }
    }
    return e;
  }
  /**
  Configure the parser. Returns a new parser instance that has the
  given settings modified. Settings not provided in `config` are
  kept from the original parser.
  */
  configure(t) {
    let e = Object.assign(Object.create(Ct.prototype), this);
    if (t.props && (e.nodeSet = this.nodeSet.extend(...t.props)), t.top) {
      let s = this.topRules[t.top];
      if (!s)
        throw new RangeError(`Invalid top rule name ${t.top}`);
      e.top = s;
    }
    return t.tokenizers && (e.tokenizers = this.tokenizers.map((s) => {
      let i = t.tokenizers.find((n) => n.from == s);
      return i ? i.to : s;
    })), t.specializers && (e.specializers = this.specializers.slice(), e.specializerSpecs = this.specializerSpecs.map((s, i) => {
      let n = t.specializers.find((a) => a.from == s.external);
      if (!n)
        return s;
      let o = Object.assign(Object.assign({}, s), { external: n.to });
      return e.specializers[i] = Re(o), o;
    })), t.contextTracker && (e.context = t.contextTracker), t.dialect && (e.dialect = this.parseDialect(t.dialect)), t.strict != null && (e.strict = t.strict), t.wrap && (e.wrappers = e.wrappers.concat(t.wrap)), t.bufferLength != null && (e.bufferLength = t.bufferLength), e;
  }
  /**
  Tells you whether any [parse wrappers](#lr.ParserConfig.wrap)
  are registered for this parser.
  */
  hasWrappers() {
    return this.wrappers.length > 0;
  }
  /**
  Returns the name associated with a given term. This will only
  work for all terms when the parser was generated with the
  `--names` option. By default, only the names of tagged terms are
  stored.
  */
  getName(t) {
    return this.termNames ? this.termNames[t] : String(t <= this.maxNode && this.nodeSet.types[t].name || t);
  }
  /**
  The eof term id is always allocated directly after the node
  types. @internal
  */
  get eofTerm() {
    return this.maxNode + 1;
  }
  /**
  The type of top node produced by the parser.
  */
  get topNode() {
    return this.nodeSet.types[this.top[1]];
  }
  /**
  @internal
  */
  dynamicPrecedence(t) {
    let e = this.dynamicPrecedences;
    return e == null ? 0 : e[t] || 0;
  }
  /**
  @internal
  */
  parseDialect(t) {
    let e = Object.keys(this.dialects), s = e.map(() => !1);
    if (t)
      for (let n of t.split(" ")) {
        let o = e.indexOf(n);
        o >= 0 && (s[o] = !0);
      }
    let i = null;
    for (let n = 0; n < e.length; n++)
      if (!s[n])
        for (let o = this.dialects[e[n]], a; (a = this.data[o++]) != 65535; )
          (i || (i = new Uint8Array(this.maxTerm + 1)))[a] = 1;
    return new Ns(t, s, i);
  }
  /**
  Used by the output of the parser generator. Not available to
  user code. @hide
  */
  static deserialize(t) {
    return new Ct(t);
  }
}
function Z(r, t) {
  return r[t] | r[t + 1] << 16;
}
function Es(r) {
  let t = null;
  for (let e of r) {
    let s = e.p.stoppedAt;
    (e.pos == e.p.stream.end || s != null && e.pos > s) && e.p.parser.stateFlag(
      e.state,
      2
      /* StateFlag.Accepting */
    ) && (!t || t.score < e.score) && (t = e);
  }
  return t;
}
function Re(r) {
  if (r.external) {
    let t = r.extend ? 1 : 0;
    return (e, s) => r.external(e, s) << 1 | t;
  }
  return r.get;
}
const Gs = 1, hs = 2, As = 3, Bs = 4, $s = 5, _s = 6, ge = 8, Xs = 11, Oe = 12, Ys = 13, Qs = 14, us = 16, fs = 18, Ks = 20, Zs = 21, Ls = 22, Ms = 25, Se = 0;
function Ve(r) {
  return r === 45 || r === 46 || r >= 48 && r <= 57 || r === 95 || r >= 97 && r <= 122 || r >= 65 && r <= 90 || r == 183 || r >= 192 && r <= 214 || r >= 216 && r <= 246 || r >= 248 && r <= 893 || r >= 895 && r <= 8191 || r >= 8204 && r <= 8205 || r >= 8255 && r <= 8256 || r >= 8304 && r <= 8591 || r >= 11264 && r <= 12271 || r >= 12289 && r <= 55295 || r >= 63744 && r <= 64975 || r >= 65008 && r <= 65533 || r >= 65536 && r <= 983039;
}
function Ie(r) {
  return r >= 9 && r <= 13 || r === 32 || r === 133 || r >= 8206 && r <= 8207 || r === 8232 || r === 8233;
}
function cs(r, t) {
  const e = /* @__PURE__ */ new Set(["{", "}"]);
  return r && e.add("#"), t && (e.add("<"), e.add(">")), e;
}
function ps(r, t) {
  const e = /* @__PURE__ */ new Set(["{"]);
  return r && (e.add("#"), e.add("}")), t && e.add("<"), e;
}
const ze = "'";
function Hs(r, t, e, s) {
  const a = r.pos;
  let l = 0;
  t:
    for (; r.next !== -1; ) {
      const h = r.next, u = fe(h);
      switch (l) {
        case 0:
          if (u === ze)
            l = 2;
          else if (e.has(u))
            break t;
          break;
        case 2:
          t.has(u) ? l = 1 : l = 0;
          break;
        case 1:
          u === ze && (l = 0);
          break;
      }
      r.advance();
    }
  a < r.pos && r.acceptToken(s);
}
function ti(r, t, e, s) {
  const h = r.pos;
  let u = 0, $ = !1, f = "";
  t:
    for (; r.next !== -1; ) {
      const p = r.next, d = fe(p);
      switch (u) {
        case 0:
          if (d === "<")
            u = 1;
          else
            break t;
          break;
        case 1:
          if (d === "/")
            $ = !0, u = 2;
          else if (Ve(p))
            f += d, u = 2;
          else
            break t;
          break;
        case 2:
          if (d === ">")
            u = 4;
          else if (Ie(p)) {
            if (f === "")
              break t;
            u = 3;
          } else if (Ve(p))
            f += d;
          else
            break t;
          break;
        case 3:
          if (d === ">")
            u = 4;
          else if (!Ie(p))
            break t;
          break;
        case 4:
          break t;
      }
      r.advance();
    }
  h >= r.pos || (u === 4 ? r.acceptToken($ ? s : e) : r.acceptToken(t));
}
function ds({
  input: r,
  stack: t,
  escapable: e,
  ending: s,
  textToken: i,
  openTag: n,
  closeTag: o
}) {
  const a = fe(r.next), l = t.dialectEnabled(Se);
  return a === "<" && l ? ti(r, i, n, o) : Hs(r, e, s, i);
}
const ei = new ls((r, t) => {
  const e = t.dialectEnabled(Se);
  return ds({
    input: r,
    stack: t,
    escapable: cs(!1, e),
    ending: ps(!1, e),
    textToken: Gs,
    openTag: hs,
    closeTag: As
  });
}), si = new ls((r, t) => {
  const e = t.dialectEnabled(Se);
  return ds({
    input: r,
    stack: t,
    escapable: cs(!0, e),
    ending: ps(!0, e),
    textToken: Bs,
    openTag: $s,
    closeTag: _s
  });
}), _t = Ct.deserialize({
  version: 14,
  states: "/`QQOTOOQcOUOOOOOO'#Ce'#CeOOOR'#Cq'#CqOtOSO'#CdOOOP'#Cu'#CuO|OTO'#CzQOOOOOOOOQ'#Cr'#CrO!TOUO'#DTOOOO'#Ch'#ChO!_OSO'#CgOwOSO'#CgO!jOSO,59OOOOO,59f,59fOOOO,59o,59oO!oOWO,59RO!zOSO,59RO#SOSO,59ROOOR'#Ct'#CtOOOR1G.j1G.jOOOO'#Ci'#CiO#_OSO1G.mO!rOWO1G.mOOOO'#Cl'#ClO#jOSO1G.qO#rOWO1G.mO#}OSO1G.mO$VO`O7+$XO$_OSO7+$XO$gOSO7+$XO$rOSO7+$]O$zOpO7+$]O$uOSO7+$]O!rOWO7+$XO%VOWO7+$XOOOO'#Cj'#CjOOOO'#Cw'#CwO$YO`O'#CwO%bO`O<<GsO$VO`O<<GsO%mOSO<<GsO%uOpO<<GwO&QOSO<<GwOOOO'#Cm'#CmOOOO'#Co'#CoO&VOSO'#CnOOOO'#Cx'#CxO$}OpO<<GwO&_OpO<<GwO&jOpO<<GwO&rOSO<<GsO&}OSO<<GwO!rOWO<<GsOOOO,59c,59cO'VO`OAN=_OOOO-E6u-E6uO'_O`OAN=_O$VO`OAN=_O$}OpOAN=cO'jOpOAN=cO&jOpOAN=cO'uOpOAN=cO(QOUO,59YO(XOSO,59YOOOO,59d,59dO'mOpOAN=cOOOO-E6v-E6vO%QOpO'#CxO(^OSOAN=_O(fOSOAN=cO(kOSOAN=_O(vOSOAN=cO)OO`OG22yO)WO`OG22yO&jOpOG22}O)cOpOG22}O)kOpOG22}O$}OpOG22}OOOO'#Cp'#CpO)vOSO1G.tO(QOUO1G.tO$VO`OG22yO){OpOG22}O*WOSOG22yO*`OSOG22}O*eO`OLD(eO*mOpOLD(iO*pOpOLD(iO&jOpOLD(iOOOO7+$`7+$`O*xOSO7+$`O*}O`OLD(eO$}OpOLD(iO$VO`OLD(eO+YOpOLD(iO+eOpO!$'LTO+mOpO!$'LTOOOO<<Gz<<GzO+xO`O!$'LPO&jOpO!$'LTO,QO`O!$'LPO$}OpO!$'LTO,]OpO!)9AoO,eOpO!)9AoO,pO`O!)9AkO&jOpO!)9AoO,xOpO!.K7ZO-QOpO!.K7ZO-]OpO!4/,u",
  stateData: "-h~OPUOQTORTOYQOxRO~OSXOTWOUWOYQOxRO~Oo[OpYO~OmnX~PQOmwXgwX~PcOoaOq`OgZX~OgcO~OogOreOthO~OqjOgZa~OokOqjOgZa~OomOqlOgZi~OoqOqpO~OorOreOthO~OqsOgZi~OovOstO~OqxOgZq~OoyOqxOgZq~Oo{OqzO~Oo!QOu|Ov}O~Oo!VOreOthO~Oo!XOstOgZy~Oq![OgZy~Oo!]Ou|Ov}O~Oq!`O~OY!aOo!bO~Oo!dOv}Og_y~Oo!fOv}O~Oo!gOq![OgZy~Oo!hOq!`O~OstOgZ!R~Oo!kOstOgZ!R~Oo!nOv}Og_!R~Oo!pOu|Ov}O~OgdP~PcOY!sO~Oq!tOgZ!R~Oq!uO~Oo!vOq!tOgZ!R~Oo!wOq!uO~OstOgZ!Z~Oo!xOstOgZ!Z~Ov}Og_!Z~Oo!zOv}Og_!Z~Og!|O~Oo#POu|Ov}O~Oq#QOgZ!Z~Oq#RO~OstOgZ!c~Oo#SOv}Og_!c~Og#UO~Oo#VOstOgZ!c~Oo#YOu|Ov}O~Ov}Og_!k~Oo#ZOv}Og_!k~OstOgZ!k~Oo#]OstOgZ!k~Ov}Og_!s~Oo#_Ov}Og_!s~OstOgZ!s~Ov}Og_!{~Oo#aOv}Og_!{~Ov}Og_#T~Ouv~",
  goto: "'_xPPPPPPPPy!TP!]!`!f!t!]#Y#h$O$s%fy}P%l%oP%s&ZP&}PPPPPPPP'TSUOUXXPX!a!s]SOPUX!a!sR]SQZSRb[Qf`SngjS!TrsR!i!Vdulwx!Z![!l!t#O#Q#X]!Wv!X!k!x#V#]Qi`SogjS!UrsR!j!VQ!SpS!_z!QS!m!]!`S!{!p!uS#W#P#RR#^#Yt!Ppz!R!S!^!_!`!m!o!u!y!{#R#T#W#[#^#`k!c!Q!]!d!f!n!p!z#P#S#Y#Z#_#a!a!Opz!Q!R!S!]!^!_!`!d!f!m!n!o!p!u!y!z!{#P#R#S#T#W#Y#Z#[#^#_#`#aQ!r!aR!}!sRd]TUOUQwlY!Yw!Z!l#O#XQ!ZxQ!l![Q#O!tR#X#QQ!RpS!^z!S^!e!R!^!o!y#T#[#`S!o!_!`S!y!m!uS#T!{#RQ#[#WR#`#^QVOR^UQVPQ_XT!q!a!s",
  nodeNames: "⚠ Text HtmlTagOpen HtmlTagClose TextNested HtmlTagOpenNested HtmlTagCloseNested Root Expression ExpressionOpen { FormatExpression Param FormatFunction FormatStyle SelectExpression SelectFunction Offset SelectVariant VariantDescriptor VariantContent PluralPlaceholder HtmlTagNested } ExpressionClose HtmlTag Nested",
  maxTerm: 40,
  skippedNodes: [0],
  repeatNodeCount: 2,
  tokenData: "$Mn~R#POX'UX^,z^p'Upq,zqs+jst-ot{+j{|.u|}7o}!O.u!O!Q+j!Q!['U![!_+j!_!`7t!`!c+j!c!}'U!}#R+j#R#S'U#S#T+j#T#W'U#W#X<[#X#b'U#b#cNa#c#d!7X#d#e#(`#e#g'U#g#h#Ck#h#i$C]#i#o'U#o#p$Lc#p#q+j#q#r$Mi#r#s+j#s#y'U#y#z,z#z$f'U$f$g,z$g$n+j$n$o'U$o$p+j$p$q'U$q$s+j$s$t'U$t$u+j$u$v'U$v$x+j$x$|'U$|$}+j$}%R'U%R%S+j%S%V'U%V%W+j%W%o'U%o%p+j%p&a'U&a&b+j&b#BY'U#BY#BZ,z#BZ$IS'U$IS$I_,z$I_$Id'U$Id$I|+j$I|$JO,z$JO$JT'U$JT$JU,z$JU$Je+j$Je$Jg'U$Jg$Jz+j$Jz$J{'U$J{$KV+j$KV$KW,z$KW%#t'U%#t%3d+j%3d%6z'U%6z%Dl+j%Dl%E['U%E[&/x+j&/x&;O'U&;O&=t+j&=t&FU'U&FU&FV,z&FV&FY+j&FY&F^'U&F^&Fw+j&Fw&GW'U&GW&GX+j&GX;'S'U;'S;=`,t<%l?>`'U?>`?>b+j?>b?DR'U?DR?DT+j?DTO'U]'_!csSpPvWOX'U^p'Uq|+j}!Q+j!Q!['U![!c+j!c!}'U!}#R+j#R#S'U#S#T+j#T#o'U#o#q+j#r#s+j#s#y'U#z$f'U$g$n+j$n$o'U$o$p+j$p$q'U$q$s+j$s$t'U$t$u+j$u$v'U$v$x+j$x$|'U$|$}+j$}%R'U%R%S+j%S%V'U%V%W+j%W%o'U%o%p+j%p&a'U&a&b+j&b#BY'U#BZ$IS'U$I_$Id'U$Id$I|+j$JO$JT'U$JU$Je+j$Je$Jg'U$Jg$Jz+j$Jz$J{'U$J{$KV+j$KW%#t'U%#t%3d+j%3d%6z'U%6z%Dl+j%Dl%E['U%E[&/x+j&/x&;O'U&;O&=t+j&=t&FU'U&FV&FY+j&FY&F^'U&F^&Fw+j&Fw&GW'U&GW&GX+j&GX;'S'U;'S;=`,t<%l?>`'U?>`?>b+j?>b?DR'U?DR?DT+j?DTO'US+o_sSOX+j^p+jq|+j}#q+j#r#y+j#z$f+j$g#BY+j#BZ$IS+j$I_$I|+j$JO$JT+j$JU$KV+j$KW&FU+j&FV;'S+j;'S;=`,n<%lO+jS,qP;=`<%l+j],wP;=`<%l'U~-PYo~X^,zpq,z#y#z,z$f$g,z#BY#BZ,z$IS$I_,z$I|$JO,z$JT$JU,z$KV$KW,z&FU&FV,zT-v_sSxPOX+j^p+jq|+j}#q+j#r#y+j#z$f+j$g#BY+j#BZ$IS+j$I_$I|+j$JO$JT+j$JU$KV+j$KW&FU+j&FV;'S+j;'S;=`,n<%lO+j[.z!csSOX3V^p3Vq|+j}!Q+j!Q![3V![!c+j!c!}3V!}#R+j#R#S3V#S#T+j#T#o3V#o#q+j#r#s+j#s#y3V#z$f3V$g$n+j$n$o3V$o$p+j$p$q3V$q$s+j$s$t3V$t$u+j$u$v3V$v$x+j$x$|3V$|$}+j$}%R3V%R%S+j%S%V3V%V%W+j%W%o3V%o%p+j%p&a3V&a&b+j&b#BY3V#BZ$IS3V$I_$Id3V$Id$I|+j$JO$JT3V$JU$Je+j$Je$Jg3V$Jg$Jz+j$Jz$J{3V$J{$KV+j$KW%#t3V%#t%3d+j%3d%6z3V%6z%Dl+j%Dl%E[3V%E[&/x+j&/x&;O3V&;O&=t+j&=t&FU3V&FV&FY+j&FY&F^3V&F^&Fw+j&Fw&GW3V&GW&GX+j&GX;'S3V;'S;=`7i<%l?>`3V?>`?>b+j?>b?DR3V?DR?DT+j?DTO3V[3^!csSvWOX3V^p3Vq|+j}!Q+j!Q![3V![!c+j!c!}3V!}#R+j#R#S3V#S#T+j#T#o3V#o#q+j#r#s+j#s#y3V#z$f3V$g$n+j$n$o3V$o$p+j$p$q3V$q$s+j$s$t3V$t$u+j$u$v3V$v$x+j$x$|3V$|$}+j$}%R3V%R%S+j%S%V3V%V%W+j%W%o3V%o%p+j%p&a3V&a&b+j&b#BY3V#BZ$IS3V$I_$Id3V$Id$I|+j$JO$JT3V$JU$Je+j$Je$Jg3V$Jg$Jz+j$Jz$J{3V$J{$KV+j$KW%#t3V%#t%3d+j%3d%6z3V%6z%Dl+j%Dl%E[3V%E[&/x+j&/x&;O3V&;O&=t+j&=t&FU3V&FV&FY+j&FY&F^3V&F^&Fw+j&Fw&GW3V&GW&GX+j&GX;'S3V;'S;=`7i<%l?>`3V?>`?>b+j?>b?DR3V?DR?DT+j?DTO3V[7lP;=`<%l3V~7tOq~[7y!esSOX3V^p3Vq{+j{|.u}!O.u!O!Q+j!Q![3V![!c+j!c!}3V!}#R+j#R#S3V#S#T+j#T#o3V#o#q+j#r#s+j#s#y3V#z$f3V$g$n+j$n$o3V$o$p+j$p$q3V$q$s+j$s$t3V$t$u+j$u$v3V$v$x+j$x$|3V$|$}+j$}%R3V%R%S+j%S%V3V%V%W+j%W%o3V%o%p+j%p&a3V&a&b+j&b#BY3V#BZ$IS3V$I_$Id3V$Id$I|+j$JO$JT3V$JU$Je+j$Je$Jg3V$Jg$Jz+j$Jz$J{3V$J{$KV+j$KW%#t3V%#t%3d+j%3d%6z3V%6z%Dl+j%Dl%E[3V%E[&/x+j&/x&;O3V&;O&=t+j&=t&FU3V&FV&FY+j&FY&F^3V&F^&Fw+j&Fw&GW3V&GW&GX+j&GX;'S3V;'S;=`7i<%l?>`3V?>`?>b+j?>b?DR3V?DR?DT+j?DTO3V_<e!dsSpPvWOX'U^p'Uq|+j}!Q+j!Q!['U![!c+j!c!}'U!}#R+j#R#S'U#S#T+j#T#U@s#U#o'U#o#q+j#r#s+j#s#y'U#z$f'U$g$n+j$n$o'U$o$p+j$p$q'U$q$s+j$s$t'U$t$u+j$u$v'U$v$x+j$x$|'U$|$}+j$}%R'U%R%S+j%S%V'U%V%W+j%W%o'U%o%p+j%p&a'U&a&b+j&b#BY'U#BZ$IS'U$I_$Id'U$Id$I|+j$JO$JT'U$JU$Je+j$Je$Jg'U$Jg$Jz+j$Jz$J{'U$J{$KV+j$KW%#t'U%#t%3d+j%3d%6z'U%6z%Dl+j%Dl%E['U%E[&/x+j&/x&;O'U&;O&=t+j&=t&FU'U&FV&FY+j&FY&F^'U&F^&Fw+j&Fw&GW'U&GW&GX+j&GX;'S'U;'S;=`,t<%l?>`'U?>`?>b+j?>b?DR'U?DR?DT+j?DTO'U_@|!esSpPvWOX'U^p'Uq|+j}!Q+j!Q!['U![!c+j!c!}'U!}#R+j#R#S'U#S#T+j#T#h'U#h#iE_#i#o'U#o#q+j#r#s+j#s#y'U#z$f'U$g$n+j$n$o'U$o$p+j$p$q'U$q$s+j$s$t'U$t$u+j$u$v'U$v$x+j$x$|'U$|$}+j$}%R'U%R%S+j%S%V'U%V%W+j%W%o'U%o%p+j%p&a'U&a&b+j&b#BY'U#BZ$IS'U$I_$Id'U$Id$I|+j$JO$JT'U$JU$Je+j$Je$Jg'U$Jg$Jz+j$Jz$J{'U$J{$KV+j$KW%#t'U%#t%3d+j%3d%6z'U%6z%Dl+j%Dl%E['U%E[&/x+j&/x&;O'U&;O&=t+j&=t&FU'U&FV&FY+j&FY&F^'U&F^&Fw+j&Fw&GW'U&GW&GX+j&GX;'S'U;'S;=`,t<%l?>`'U?>`?>b+j?>b?DR'U?DR?DT+j?DTO'U_Eh!esSpPvWOX'U^p'Uq|+j}!Q+j!Q!['U![!c+j!c!}'U!}#R+j#R#S'U#S#T+j#T#X'U#X#YIy#Y#o'U#o#q+j#r#s+j#s#y'U#z$f'U$g$n+j$n$o'U$o$p+j$p$q'U$q$s+j$s$t'U$t$u+j$u$v'U$v$x+j$x$|'U$|$}+j$}%R'U%R%S+j%S%V'U%V%W+j%W%o'U%o%p+j%p&a'U&a&b+j&b#BY'U#BZ$IS'U$I_$Id'U$Id$I|+j$JO$JT'U$JU$Je+j$Je$Jg'U$Jg$Jz+j$Jz$J{'U$J{$KV+j$KW%#t'U%#t%3d+j%3d%6z'U%6z%Dl+j%Dl%E['U%E[&/x+j&/x&;O'U&;O&=t+j&=t&FU'U&FV&FY+j&FY&F^'U&F^&Fw+j&Fw&GW'U&GW&GX+j&GX;'S'U;'S;=`,t<%l?>`'U?>`?>b+j?>b?DR'U?DR?DT+j?DTO'U_JU!crQsSpPvWOX'U^p'Uq|+j}!Q+j!Q!['U![!c+j!c!}'U!}#R+j#R#S'U#S#T+j#T#o'U#o#q+j#r#s+j#s#y'U#z$f'U$g$n+j$n$o'U$o$p+j$p$q'U$q$s+j$s$t'U$t$u+j$u$v'U$v$x+j$x$|'U$|$}+j$}%R'U%R%S+j%S%V'U%V%W+j%W%o'U%o%p+j%p&a'U&a&b+j&b#BY'U#BZ$IS'U$I_$Id'U$Id$I|+j$JO$JT'U$JU$Je+j$Je$Jg'U$Jg$Jz+j$Jz$J{'U$J{$KV+j$KW%#t'U%#t%3d+j%3d%6z'U%6z%Dl+j%Dl%E['U%E[&/x+j&/x&;O'U&;O&=t+j&=t&FU'U&FV&FY+j&FY&F^'U&F^&Fw+j&Fw&GW'U&GW&GX+j&GX;'S'U;'S;=`,t<%l?>`'U?>`?>b+j?>b?DR'U?DR?DT+j?DTO'U_Nj!esSpPvWOX'U^p'Uq|+j}!Q+j!Q!['U![!c+j!c!}'U!}#R+j#R#S'U#S#T+j#T#i'U#i#j!${#j#o'U#o#q+j#r#s+j#s#y'U#z$f'U$g$n+j$n$o'U$o$p+j$p$q'U$q$s+j$s$t'U$t$u+j$u$v'U$v$x+j$x$|'U$|$}+j$}%R'U%R%S+j%S%V'U%V%W+j%W%o'U%o%p+j%p&a'U&a&b+j&b#BY'U#BZ$IS'U$I_$Id'U$Id$I|+j$JO$JT'U$JU$Je+j$Je$Jg'U$Jg$Jz+j$Jz$J{'U$J{$KV+j$KW%#t'U%#t%3d+j%3d%6z'U%6z%Dl+j%Dl%E['U%E[&/x+j&/x&;O'U&;O&=t+j&=t&FU'U&FV&FY+j&FY&F^'U&F^&Fw+j&Fw&GW'U&GW&GX+j&GX;'S'U;'S;=`,t<%l?>`'U?>`?>b+j?>b?DR'U?DR?DT+j?DTO'U_!%U!esSpPvWOX'U^p'Uq|+j}!Q+j!Q!['U![!c+j!c!}'U!}#R+j#R#S'U#S#T+j#T#a'U#a#b!)g#b#o'U#o#q+j#r#s+j#s#y'U#z$f'U$g$n+j$n$o'U$o$p+j$p$q'U$q$s+j$s$t'U$t$u+j$u$v'U$v$x+j$x$|'U$|$}+j$}%R'U%R%S+j%S%V'U%V%W+j%W%o'U%o%p+j%p&a'U&a&b+j&b#BY'U#BZ$IS'U$I_$Id'U$Id$I|+j$JO$JT'U$JU$Je+j$Je$Jg'U$Jg$Jz+j$Jz$J{'U$J{$KV+j$KW%#t'U%#t%3d+j%3d%6z'U%6z%Dl+j%Dl%E['U%E[&/x+j&/x&;O'U&;O&=t+j&=t&FU'U&FV&FY+j&FY&F^'U&F^&Fw+j&Fw&GW'U&GW&GX+j&GX;'S'U;'S;=`,t<%l?>`'U?>`?>b+j?>b?DR'U?DR?DT+j?DTO'U_!)p!esSpPvWOX'U^p'Uq|+j}!Q+j!Q!['U![!c+j!c!}'U!}#R+j#R#S'U#S#T+j#T#U'U#U#V!.R#V#o'U#o#q+j#r#s+j#s#y'U#z$f'U$g$n+j$n$o'U$o$p+j$p$q'U$q$s+j$s$t'U$t$u+j$u$v'U$v$x+j$x$|'U$|$}+j$}%R'U%R%S+j%S%V'U%V%W+j%W%o'U%o%p+j%p&a'U&a&b+j&b#BY'U#BZ$IS'U$I_$Id'U$Id$I|+j$JO$JT'U$JU$Je+j$Je$Jg'U$Jg$Jz+j$Jz$J{'U$J{$KV+j$KW%#t'U%#t%3d+j%3d%6z'U%6z%Dl+j%Dl%E['U%E[&/x+j&/x&;O'U&;O&=t+j&=t&FU'U&FV&FY+j&FY&F^'U&F^&Fw+j&Fw&GW'U&GW&GX+j&GX;'S'U;'S;=`,t<%l?>`'U?>`?>b+j?>b?DR'U?DR?DT+j?DTO'U_!.[!esSpPvWOX'U^p'Uq|+j}!Q+j!Q!['U![!c+j!c!}'U!}#R+j#R#S'U#S#T+j#T#X'U#X#Y!2m#Y#o'U#o#q+j#r#s+j#s#y'U#z$f'U$g$n+j$n$o'U$o$p+j$p$q'U$q$s+j$s$t'U$t$u+j$u$v'U$v$x+j$x$|'U$|$}+j$}%R'U%R%S+j%S%V'U%V%W+j%W%o'U%o%p+j%p&a'U&a&b+j&b#BY'U#BZ$IS'U$I_$Id'U$Id$I|+j$JO$JT'U$JU$Je+j$Je$Jg'U$Jg$Jz+j$Jz$J{'U$J{$KV+j$KW%#t'U%#t%3d+j%3d%6z'U%6z%Dl+j%Dl%E['U%E[&/x+j&/x&;O'U&;O&=t+j&=t&FU'U&FV&FY+j&FY&F^'U&F^&Fw+j&Fw&GW'U&GW&GX+j&GX;'S'U;'S;=`,t<%l?>`'U?>`?>b+j?>b?DR'U?DR?DT+j?DTO'U_!2v!esSpPvWOX'U^p'Uq|+j}!Q+j!Q!['U![!c+j!c!}'U!}#R+j#R#S'U#S#T+j#T#f'U#f#gIy#g#o'U#o#q+j#r#s+j#s#y'U#z$f'U$g$n+j$n$o'U$o$p+j$p$q'U$q$s+j$s$t'U$t$u+j$u$v'U$v$x+j$x$|'U$|$}+j$}%R'U%R%S+j%S%V'U%V%W+j%W%o'U%o%p+j%p&a'U&a&b+j&b#BY'U#BZ$IS'U$I_$Id'U$Id$I|+j$JO$JT'U$JU$Je+j$Je$Jg'U$Jg$Jz+j$Jz$J{'U$J{$KV+j$KW%#t'U%#t%3d+j%3d%6z'U%6z%Dl+j%Dl%E['U%E[&/x+j&/x&;O'U&;O&=t+j&=t&FU'U&FV&FY+j&FY&F^'U&F^&Fw+j&Fw&GW'U&GW&GX+j&GX;'S'U;'S;=`,t<%l?>`'U?>`?>b+j?>b?DR'U?DR?DT+j?DTO'U]!7b!esSpPvWOX'U^p'Uq|+j}!Q+j!Q!['U![!c+j!c!}'U!}#R+j#R#S'U#S#T+j#T#Y'U#Y#Z!;s#Z#o'U#o#q+j#r#s+j#s#y'U#z$f'U$g$n+j$n$o'U$o$p+j$p$q'U$q$s+j$s$t'U$t$u+j$u$v'U$v$x+j$x$|'U$|$}+j$}%R'U%R%S+j%S%V'U%V%W+j%W%o'U%o%p+j%p&a'U&a&b+j&b#BY'U#BZ$IS'U$I_$Id'U$Id$I|+j$JO$JT'U$JU$Je+j$Je$Jg'U$Jg$Jz+j$Jz$J{'U$J{$KV+j$KW%#t'U%#t%3d+j%3d%6z'U%6z%Dl+j%Dl%E['U%E[&/x+j&/x&;O'U&;O&=t+j&=t&FU'U&FV&FY+j&FY&F^'U&F^&Fw+j&Fw&GW'U&GW&GX+j&GX;'S'U;'S;=`,t<%l?>`'U?>`?>b+j?>b?DR'U?DR?DT+j?DTO'U]!;|!esSpPvWOX'U^p'Uq|+j}!Q+j!Q!['U![!c+j!c!}'U!}#R+j#R#S'U#S#T+j#T#Y'U#Y#Z!@_#Z#o'U#o#q+j#r#s+j#s#y'U#z$f'U$g$n+j$n$o'U$o$p+j$p$q'U$q$s+j$s$t'U$t$u+j$u$v'U$v$x+j$x$|'U$|$}+j$}%R'U%R%S+j%S%V'U%V%W+j%W%o'U%o%p+j%p&a'U&a&b+j&b#BY'U#BZ$IS'U$I_$Id'U$Id$I|+j$JO$JT'U$JU$Je+j$Je$Jg'U$Jg$Jz+j$Jz$J{'U$J{$KV+j$KW%#t'U%#t%3d+j%3d%6z'U%6z%Dl+j%Dl%E['U%E[&/x+j&/x&;O'U&;O&=t+j&=t&FU'U&FV&FY+j&FY&F^'U&F^&Fw+j&Fw&GW'U&GW&GX+j&GX;'S'U;'S;=`,t<%l?>`'U?>`?>b+j?>b?DR'U?DR?DT+j?DTO'U]!@h!esSpPvWOX'U^p'Uq|+j}!Q+j!Q!['U![!c+j!c!}'U!}#R+j#R#S'U#S#T+j#T#g'U#g#h!Dy#h#o'U#o#q+j#r#s+j#s#y'U#z$f'U$g$n+j$n$o'U$o$p+j$p$q'U$q$s+j$s$t'U$t$u+j$u$v'U$v$x+j$x$|'U$|$}+j$}%R'U%R%S+j%S%V'U%V%W+j%W%o'U%o%p+j%p&a'U&a&b+j&b#BY'U#BZ$IS'U$I_$Id'U$Id$I|+j$JO$JT'U$JU$Je+j$Je$Jg'U$Jg$Jz+j$Jz$J{'U$J{$KV+j$KW%#t'U%#t%3d+j%3d%6z'U%6z%Dl+j%Dl%E['U%E[&/x+j&/x&;O'U&;O&=t+j&=t&FU'U&FV&FY+j&FY&F^'U&F^&Fw+j&Fw&GW'U&GW&GX+j&GX;'S'U;'S;=`,t<%l?>`'U?>`?>b+j?>b?DR'U?DR?DT+j?DTO'U]!ES!esSpPvWOX'U^p'Uq|+j}!Q+j!Q!['U![!c+j!c!}'U!}#R+j#R#S'U#S#T+j#T#X'U#X#Y!Ie#Y#o'U#o#q+j#r#s+j#s#y'U#z$f'U$g$n+j$n$o'U$o$p+j$p$q'U$q$s+j$s$t'U$t$u+j$u$v'U$v$x+j$x$|'U$|$}+j$}%R'U%R%S+j%S%V'U%V%W+j%W%o'U%o%p+j%p&a'U&a&b+j&b#BY'U#BZ$IS'U$I_$Id'U$Id$I|+j$JO$JT'U$JU$Je+j$Je$Jg'U$Jg$Jz+j$Jz$J{'U$J{$KV+j$KW%#t'U%#t%3d+j%3d%6z'U%6z%Dl+j%Dl%E['U%E[&/x+j&/x&;O'U&;O&=t+j&=t&FU'U&FV&FY+j&FY&F^'U&F^&Fw+j&Fw&GW'U&GW&GX+j&GX;'S'U;'S;=`,t<%l?>`'U?>`?>b+j?>b?DR'U?DR?DT+j?DTO'U]!In!esSpPvWOX'U^p'Uq|+j}!Q+j!Q!['U![!c+j!c!}'U!}#R+j#R#S'U#S#T+j#T#h'U#h#i!NP#i#o'U#o#q+j#r#s+j#s#y'U#z$f'U$g$n+j$n$o'U$o$p+j$p$q'U$q$s+j$s$t'U$t$u+j$u$v'U$v$x+j$x$|'U$|$}+j$}%R'U%R%S+j%S%V'U%V%W+j%W%o'U%o%p+j%p&a'U&a&b+j&b#BY'U#BZ$IS'U$I_$Id'U$Id$I|+j$JO$JT'U$JU$Je+j$Je$Jg'U$Jg$Jz+j$Jz$J{'U$J{$KV+j$KW%#t'U%#t%3d+j%3d%6z'U%6z%Dl+j%Dl%E['U%E[&/x+j&/x&;O'U&;O&=t+j&=t&FU'U&FV&FY+j&FY&F^'U&F^&Fw+j&Fw&GW'U&GW&GX+j&GX;'S'U;'S;=`,t<%l?>`'U?>`?>b+j?>b?DR'U?DR?DT+j?DTO'U]!NY!dsSpPvWOX'U^p'Uq|+j}!Q+j!Q!['U![!]#$h!]!c+j!c!}'U!}#R+j#R#S'U#S#T+j#T#o'U#o#q+j#r#s+j#s#y'U#z$f'U$g$n+j$n$o'U$o$p+j$p$q'U$q$s+j$s$t'U$t$u+j$u$v'U$v$x+j$x$|'U$|$}+j$}%R'U%R%S+j%S%V'U%V%W+j%W%o'U%o%p+j%p&a'U&a&b+j&b#BY'U#BZ$IS'U$I_$Id'U$Id$I|+j$JO$JT'U$JU$Je+j$Je$Jg'U$Jg$Jz+j$Jz$J{'U$J{$KV+j$KW%#t'U%#t%3d+j%3d%6z'U%6z%Dl+j%Dl%E['U%E[&/x+j&/x&;O'U&;O&=t+j&=t&FU'U&FV&FY+j&FY&F^'U&F^&Fw+j&Fw&GW'U&GW&GX+j&GX;'S'U;'S;=`,t<%l?>`'U?>`?>b+j?>b?DR'U?DR?DT+j?DTO'U[#$mcsSOX+j^p+jq{+j{|#%x}!O#%x!O!Q+j!Q![#'S![#q+j#r#y+j#z$f+j$g#BY+j#BZ$IS+j$I_$I|+j$JO$JT+j$JU$KV+j$KW&FU+j&FV;'S+j;'S;=`,n<%lO+j[#%}asSOX+j^p+jq|+j}!Q+j!Q![#'S![#q+j#r#y+j#z$f+j$g#BY+j#BZ$IS+j$I_$I|+j$JO$JT+j$JU$KV+j$KW&FU+j&FV;'S+j;'S;=`,n<%lO+j[#'ZasSuWOX+j^p+jq|+j}!Q+j!Q![#'S![#q+j#r#y+j#z$f+j$g#BY+j#BZ$IS+j$I_$I|+j$JO$JT+j$JU$KV+j$KW&FU+j&FV;'S+j;'S;=`,n<%lO+j_#(i!esSpPvWOX'U^p'Uq|+j}!Q+j!Q!['U![!c+j!c!}'U!}#R+j#R#S'U#S#T+j#T#`'U#`#a#,z#a#o'U#o#q+j#r#s+j#s#y'U#z$f'U$g$n+j$n$o'U$o$p+j$p$q'U$q$s+j$s$t'U$t$u+j$u$v'U$v$x+j$x$|'U$|$}+j$}%R'U%R%S+j%S%V'U%V%W+j%W%o'U%o%p+j%p&a'U&a&b+j&b#BY'U#BZ$IS'U$I_$Id'U$Id$I|+j$JO$JT'U$JU$Je+j$Je$Jg'U$Jg$Jz+j$Jz$J{'U$J{$KV+j$KW%#t'U%#t%3d+j%3d%6z'U%6z%Dl+j%Dl%E['U%E[&/x+j&/x&;O'U&;O&=t+j&=t&FU'U&FV&FY+j&FY&F^'U&F^&Fw+j&Fw&GW'U&GW&GX+j&GX;'S'U;'S;=`,t<%l?>`'U?>`?>b+j?>b?DR'U?DR?DT+j?DTO'U_#-T!esSpPvWOX'U^p'Uq|+j}!Q+j!Q!['U![!c+j!c!}'U!}#R+j#R#S'U#S#T+j#T#i'U#i#j#1f#j#o'U#o#q+j#r#s+j#s#y'U#z$f'U$g$n+j$n$o'U$o$p+j$p$q'U$q$s+j$s$t'U$t$u+j$u$v'U$v$x+j$x$|'U$|$}+j$}%R'U%R%S+j%S%V'U%V%W+j%W%o'U%o%p+j%p&a'U&a&b+j&b#BY'U#BZ$IS'U$I_$Id'U$Id$I|+j$JO$JT'U$JU$Je+j$Je$Jg'U$Jg$Jz+j$Jz$J{'U$J{$KV+j$KW%#t'U%#t%3d+j%3d%6z'U%6z%Dl+j%Dl%E['U%E[&/x+j&/x&;O'U&;O&=t+j&=t&FU'U&FV&FY+j&FY&F^'U&F^&Fw+j&Fw&GW'U&GW&GX+j&GX;'S'U;'S;=`,t<%l?>`'U?>`?>b+j?>b?DR'U?DR?DT+j?DTO'U_#1o!esSpPvWOX'U^p'Uq|+j}!Q+j!Q!['U![!c+j!c!}'U!}#R+j#R#S'U#S#T+j#T#f'U#f#g#6Q#g#o'U#o#q+j#r#s+j#s#y'U#z$f'U$g$n+j$n$o'U$o$p+j$p$q'U$q$s+j$s$t'U$t$u+j$u$v'U$v$x+j$x$|'U$|$}+j$}%R'U%R%S+j%S%V'U%V%W+j%W%o'U%o%p+j%p&a'U&a&b+j&b#BY'U#BZ$IS'U$I_$Id'U$Id$I|+j$JO$JT'U$JU$Je+j$Je$Jg'U$Jg$Jz+j$Jz$J{'U$J{$KV+j$KW%#t'U%#t%3d+j%3d%6z'U%6z%Dl+j%Dl%E['U%E[&/x+j&/x&;O'U&;O&=t+j&=t&FU'U&FV&FY+j&FY&F^'U&F^&Fw+j&Fw&GW'U&GW&GX+j&GX;'S'U;'S;=`,t<%l?>`'U?>`?>b+j?>b?DR'U?DR?DT+j?DTO'U_#6Z!dsSpPvWOX'U^p'Uq|+j}!Q+j!Q!['U![!c+j!c!}'U!}#R+j#R#S'U#S#T+j#T#U#:i#U#o'U#o#q+j#r#s+j#s#y'U#z$f'U$g$n+j$n$o'U$o$p+j$p$q'U$q$s+j$s$t'U$t$u+j$u$v'U$v$x+j$x$|'U$|$}+j$}%R'U%R%S+j%S%V'U%V%W+j%W%o'U%o%p+j%p&a'U&a&b+j&b#BY'U#BZ$IS'U$I_$Id'U$Id$I|+j$JO$JT'U$JU$Je+j$Je$Jg'U$Jg$Jz+j$Jz$J{'U$J{$KV+j$KW%#t'U%#t%3d+j%3d%6z'U%6z%Dl+j%Dl%E['U%E[&/x+j&/x&;O'U&;O&=t+j&=t&FU'U&FV&FY+j&FY&F^'U&F^&Fw+j&Fw&GW'U&GW&GX+j&GX;'S'U;'S;=`,t<%l?>`'U?>`?>b+j?>b?DR'U?DR?DT+j?DTO'U_#:r!esSpPvWOX'U^p'Uq|+j}!Q+j!Q!['U![!c+j!c!}'U!}#R+j#R#S'U#S#T+j#T#`'U#`#a#?T#a#o'U#o#q+j#r#s+j#s#y'U#z$f'U$g$n+j$n$o'U$o$p+j$p$q'U$q$s+j$s$t'U$t$u+j$u$v'U$v$x+j$x$|'U$|$}+j$}%R'U%R%S+j%S%V'U%V%W+j%W%o'U%o%p+j%p&a'U&a&b+j&b#BY'U#BZ$IS'U$I_$Id'U$Id$I|+j$JO$JT'U$JU$Je+j$Je$Jg'U$Jg$Jz+j$Jz$J{'U$J{$KV+j$KW%#t'U%#t%3d+j%3d%6z'U%6z%Dl+j%Dl%E['U%E[&/x+j&/x&;O'U&;O&=t+j&=t&FU'U&FV&FY+j&FY&F^'U&F^&Fw+j&Fw&GW'U&GW&GX+j&GX;'S'U;'S;=`,t<%l?>`'U?>`?>b+j?>b?DR'U?DR?DT+j?DTO'U_#?`!csSpPtQvWOX'U^p'Uq|+j}!Q+j!Q!['U![!c+j!c!}'U!}#R+j#R#S'U#S#T+j#T#o'U#o#q+j#r#s+j#s#y'U#z$f'U$g$n+j$n$o'U$o$p+j$p$q'U$q$s+j$s$t'U$t$u+j$u$v'U$v$x+j$x$|'U$|$}+j$}%R'U%R%S+j%S%V'U%V%W+j%W%o'U%o%p+j%p&a'U&a&b+j&b#BY'U#BZ$IS'U$I_$Id'U$Id$I|+j$JO$JT'U$JU$Je+j$Je$Jg'U$Jg$Jz+j$Jz$J{'U$J{$KV+j$KW%#t'U%#t%3d+j%3d%6z'U%6z%Dl+j%Dl%E['U%E[&/x+j&/x&;O'U&;O&=t+j&=t&FU'U&FV&FY+j&FY&F^'U&F^&Fw+j&Fw&GW'U&GW&GX+j&GX;'S'U;'S;=`,t<%l?>`'U?>`?>b+j?>b?DR'U?DR?DT+j?DTO'U_#Ct!esSpPvWOX'U^p'Uq|+j}!Q+j!Q!['U![!c+j!c!}'U!}#R+j#R#S'U#S#T+j#T#X'U#X#Y#HV#Y#o'U#o#q+j#r#s+j#s#y'U#z$f'U$g$n+j$n$o'U$o$p+j$p$q'U$q$s+j$s$t'U$t$u+j$u$v'U$v$x+j$x$|'U$|$}+j$}%R'U%R%S+j%S%V'U%V%W+j%W%o'U%o%p+j%p&a'U&a&b+j&b#BY'U#BZ$IS'U$I_$Id'U$Id$I|+j$JO$JT'U$JU$Je+j$Je$Jg'U$Jg$Jz+j$Jz$J{'U$J{$KV+j$KW%#t'U%#t%3d+j%3d%6z'U%6z%Dl+j%Dl%E['U%E[&/x+j&/x&;O'U&;O&=t+j&=t&FU'U&FV&FY+j&FY&F^'U&F^&Fw+j&Fw&GW'U&GW&GX+j&GX;'S'U;'S;=`,t<%l?>`'U?>`?>b+j?>b?DR'U?DR?DT+j?DTO'U_#H`!esSpPvWOX'U^p'Uq|+j}!Q+j!Q!['U![!c+j!c!}'U!}#R+j#R#S'U#S#T+j#T#`'U#`#a#Lq#a#o'U#o#q+j#r#s+j#s#y'U#z$f'U$g$n+j$n$o'U$o$p+j$p$q'U$q$s+j$s$t'U$t$u+j$u$v'U$v$x+j$x$|'U$|$}+j$}%R'U%R%S+j%S%V'U%V%W+j%W%o'U%o%p+j%p&a'U&a&b+j&b#BY'U#BZ$IS'U$I_$Id'U$Id$I|+j$JO$JT'U$JU$Je+j$Je$Jg'U$Jg$Jz+j$Jz$J{'U$J{$KV+j$KW%#t'U%#t%3d+j%3d%6z'U%6z%Dl+j%Dl%E['U%E[&/x+j&/x&;O'U&;O&=t+j&=t&FU'U&FV&FY+j&FY&F^'U&F^&Fw+j&Fw&GW'U&GW&GX+j&GX;'S'U;'S;=`,t<%l?>`'U?>`?>b+j?>b?DR'U?DR?DT+j?DTO'U_#Lz!esSpPvWOX'U^p'Uq|+j}!Q+j!Q!['U![!c+j!c!}'U!}#R+j#R#S'U#S#T+j#T#X'U#X#Y$#]#Y#o'U#o#q+j#r#s+j#s#y'U#z$f'U$g$n+j$n$o'U$o$p+j$p$q'U$q$s+j$s$t'U$t$u+j$u$v'U$v$x+j$x$|'U$|$}+j$}%R'U%R%S+j%S%V'U%V%W+j%W%o'U%o%p+j%p&a'U&a&b+j&b#BY'U#BZ$IS'U$I_$Id'U$Id$I|+j$JO$JT'U$JU$Je+j$Je$Jg'U$Jg$Jz+j$Jz$J{'U$J{$KV+j$KW%#t'U%#t%3d+j%3d%6z'U%6z%Dl+j%Dl%E['U%E[&/x+j&/x&;O'U&;O&=t+j&=t&FU'U&FV&FY+j&FY&F^'U&F^&Fw+j&Fw&GW'U&GW&GX+j&GX;'S'U;'S;=`,t<%l?>`'U?>`?>b+j?>b?DR'U?DR?DT+j?DTO'U_$#f!esSpPvWOX'U^p'Uq|+j}!Q+j!Q!['U![!c+j!c!}'U!}#R+j#R#S'U#S#T+j#T#V'U#V#W$'w#W#o'U#o#q+j#r#s+j#s#y'U#z$f'U$g$n+j$n$o'U$o$p+j$p$q'U$q$s+j$s$t'U$t$u+j$u$v'U$v$x+j$x$|'U$|$}+j$}%R'U%R%S+j%S%V'U%V%W+j%W%o'U%o%p+j%p&a'U&a&b+j&b#BY'U#BZ$IS'U$I_$Id'U$Id$I|+j$JO$JT'U$JU$Je+j$Je$Jg'U$Jg$Jz+j$Jz$J{'U$J{$KV+j$KW%#t'U%#t%3d+j%3d%6z'U%6z%Dl+j%Dl%E['U%E[&/x+j&/x&;O'U&;O&=t+j&=t&FU'U&FV&FY+j&FY&F^'U&F^&Fw+j&Fw&GW'U&GW&GX+j&GX;'S'U;'S;=`,t<%l?>`'U?>`?>b+j?>b?DR'U?DR?DT+j?DTO'U_$(Q!esSpPvWOX'U^p'Uq|+j}!Q+j!Q!['U![!c+j!c!}'U!}#R+j#R#S'U#S#T+j#T#h'U#h#i$,c#i#o'U#o#q+j#r#s+j#s#y'U#z$f'U$g$n+j$n$o'U$o$p+j$p$q'U$q$s+j$s$t'U$t$u+j$u$v'U$v$x+j$x$|'U$|$}+j$}%R'U%R%S+j%S%V'U%V%W+j%W%o'U%o%p+j%p&a'U&a&b+j&b#BY'U#BZ$IS'U$I_$Id'U$Id$I|+j$JO$JT'U$JU$Je+j$Je$Jg'U$Jg$Jz+j$Jz$J{'U$J{$KV+j$KW%#t'U%#t%3d+j%3d%6z'U%6z%Dl+j%Dl%E['U%E[&/x+j&/x&;O'U&;O&=t+j&=t&FU'U&FV&FY+j&FY&F^'U&F^&Fw+j&Fw&GW'U&GW&GX+j&GX;'S'U;'S;=`,t<%l?>`'U?>`?>b+j?>b?DR'U?DR?DT+j?DTO'U_$,n!esSpPtQvWOX'U^p'Uq|+j}!Q+j!Q!['U![!c+j!c!}'U!}#R+j#R#S'U#S#T+j#T#c'U#c#d$1P#d#o'U#o#q+j#r#s+j#s#y'U#z$f'U$g$n+j$n$o'U$o$p+j$p$q'U$q$s+j$s$t'U$t$u+j$u$v'U$v$x+j$x$|'U$|$}+j$}%R'U%R%S+j%S%V'U%V%W+j%W%o'U%o%p+j%p&a'U&a&b+j&b#BY'U#BZ$IS'U$I_$Id'U$Id$I|+j$JO$JT'U$JU$Je+j$Je$Jg'U$Jg$Jz+j$Jz$J{'U$J{$KV+j$KW%#t'U%#t%3d+j%3d%6z'U%6z%Dl+j%Dl%E['U%E[&/x+j&/x&;O'U&;O&=t+j&=t&FU'U&FV&FY+j&FY&F^'U&F^&Fw+j&Fw&GW'U&GW&GX+j&GX;'S'U;'S;=`,t<%l?>`'U?>`?>b+j?>b?DR'U?DR?DT+j?DTO'U_$1Y!esSpPvWOX'U^p'Uq|+j}!Q+j!Q!['U![!c+j!c!}'U!}#R+j#R#S'U#S#T+j#T#f'U#f#g$5k#g#o'U#o#q+j#r#s+j#s#y'U#z$f'U$g$n+j$n$o'U$o$p+j$p$q'U$q$s+j$s$t'U$t$u+j$u$v'U$v$x+j$x$|'U$|$}+j$}%R'U%R%S+j%S%V'U%V%W+j%W%o'U%o%p+j%p&a'U&a&b+j&b#BY'U#BZ$IS'U$I_$Id'U$Id$I|+j$JO$JT'U$JU$Je+j$Je$Jg'U$Jg$Jz+j$Jz$J{'U$J{$KV+j$KW%#t'U%#t%3d+j%3d%6z'U%6z%Dl+j%Dl%E['U%E[&/x+j&/x&;O'U&;O&=t+j&=t&FU'U&FV&FY+j&FY&F^'U&F^&Fw+j&Fw&GW'U&GW&GX+j&GX;'S'U;'S;=`,t<%l?>`'U?>`?>b+j?>b?DR'U?DR?DT+j?DTO'U_$5t!esSpPvWOX'U^p'Uq|+j}!Q+j!Q!['U![!c+j!c!}'U!}#R+j#R#S'U#S#T+j#T#W'U#W#X$:V#X#o'U#o#q+j#r#s+j#s#y'U#z$f'U$g$n+j$n$o'U$o$p+j$p$q'U$q$s+j$s$t'U$t$u+j$u$v'U$v$x+j$x$|'U$|$}+j$}%R'U%R%S+j%S%V'U%V%W+j%W%o'U%o%p+j%p&a'U&a&b+j&b#BY'U#BZ$IS'U$I_$Id'U$Id$I|+j$JO$JT'U$JU$Je+j$Je$Jg'U$Jg$Jz+j$Jz$J{'U$J{$KV+j$KW%#t'U%#t%3d+j%3d%6z'U%6z%Dl+j%Dl%E['U%E[&/x+j&/x&;O'U&;O&=t+j&=t&FU'U&FV&FY+j&FY&F^'U&F^&Fw+j&Fw&GW'U&GW&GX+j&GX;'S'U;'S;=`,t<%l?>`'U?>`?>b+j?>b?DR'U?DR?DT+j?DTO'U_$:`!esSpPvWOX'U^p'Uq|+j}!Q+j!Q!['U![!c+j!c!}'U!}#R+j#R#S'U#S#T+j#T#]'U#]#^$>q#^#o'U#o#q+j#r#s+j#s#y'U#z$f'U$g$n+j$n$o'U$o$p+j$p$q'U$q$s+j$s$t'U$t$u+j$u$v'U$v$x+j$x$|'U$|$}+j$}%R'U%R%S+j%S%V'U%V%W+j%W%o'U%o%p+j%p&a'U&a&b+j&b#BY'U#BZ$IS'U$I_$Id'U$Id$I|+j$JO$JT'U$JU$Je+j$Je$Jg'U$Jg$Jz+j$Jz$J{'U$J{$KV+j$KW%#t'U%#t%3d+j%3d%6z'U%6z%Dl+j%Dl%E['U%E[&/x+j&/x&;O'U&;O&=t+j&=t&FU'U&FV&FY+j&FY&F^'U&F^&Fw+j&Fw&GW'U&GW&GX+j&GX;'S'U;'S;=`,t<%l?>`'U?>`?>b+j?>b?DR'U?DR?DT+j?DTO'U_$>z!esSpPvWOX'U^p'Uq|+j}!Q+j!Q!['U![!c+j!c!}'U!}#R+j#R#S'U#S#T+j#T#b'U#b#c#6Q#c#o'U#o#q+j#r#s+j#s#y'U#z$f'U$g$n+j$n$o'U$o$p+j$p$q'U$q$s+j$s$t'U$t$u+j$u$v'U$v$x+j$x$|'U$|$}+j$}%R'U%R%S+j%S%V'U%V%W+j%W%o'U%o%p+j%p&a'U&a&b+j&b#BY'U#BZ$IS'U$I_$Id'U$Id$I|+j$JO$JT'U$JU$Je+j$Je$Jg'U$Jg$Jz+j$Jz$J{'U$J{$KV+j$KW%#t'U%#t%3d+j%3d%6z'U%6z%Dl+j%Dl%E['U%E[&/x+j&/x&;O'U&;O&=t+j&=t&FU'U&FV&FY+j&FY&F^'U&F^&Fw+j&Fw&GW'U&GW&GX+j&GX;'S'U;'S;=`,t<%l?>`'U?>`?>b+j?>b?DR'U?DR?DT+j?DTO'U_$Cf!esSpPvWOX'U^p'Uq|+j}!Q+j!Q!['U![!c+j!c!}'U!}#R+j#R#S'U#S#T+j#T#]'U#]#^$Gw#^#o'U#o#q+j#r#s+j#s#y'U#z$f'U$g$n+j$n$o'U$o$p+j$p$q'U$q$s+j$s$t'U$t$u+j$u$v'U$v$x+j$x$|'U$|$}+j$}%R'U%R%S+j%S%V'U%V%W+j%W%o'U%o%p+j%p&a'U&a&b+j&b#BY'U#BZ$IS'U$I_$Id'U$Id$I|+j$JO$JT'U$JU$Je+j$Je$Jg'U$Jg$Jz+j$Jz$J{'U$J{$KV+j$KW%#t'U%#t%3d+j%3d%6z'U%6z%Dl+j%Dl%E['U%E[&/x+j&/x&;O'U&;O&=t+j&=t&FU'U&FV&FY+j&FY&F^'U&F^&Fw+j&Fw&GW'U&GW&GX+j&GX;'S'U;'S;=`,t<%l?>`'U?>`?>b+j?>b?DR'U?DR?DT+j?DTO'U_$HQ!esSpPvWOX'U^p'Uq|+j}!Q+j!Q!['U![!c+j!c!}'U!}#R+j#R#S'U#S#T+j#T#a'U#a#bE_#b#o'U#o#q+j#r#s+j#s#y'U#z$f'U$g$n+j$n$o'U$o$p+j$p$q'U$q$s+j$s$t'U$t$u+j$u$v'U$v$x+j$x$|'U$|$}+j$}%R'U%R%S+j%S%V'U%V%W+j%W%o'U%o%p+j%p&a'U&a&b+j&b#BY'U#BZ$IS'U$I_$Id'U$Id$I|+j$JO$JT'U$JU$Je+j$Je$Jg'U$Jg$Jz+j$Jz$J{'U$J{$KV+j$KW%#t'U%#t%3d+j%3d%6z'U%6z%Dl+j%Dl%E['U%E[&/x+j&/x&;O'U&;O&=t+j&=t&FU'U&FV&FY+j&FY&F^'U&F^&Fw+j&Fw&GW'U&GW&GX+j&GX;'S'U;'S;=`,t<%l?>`'U?>`?>b+j?>b?DR'U?DR?DT+j?DTO'UT$Lj_YPsSOX+j^p+jq|+j}#q+j#r#y+j#z$f+j$g#BY+j#BZ$IS+j$I_$I|+j$JO$JT+j$JU$KV+j$KW&FU+j&FV;'S+j;'S;=`,n<%lO+j~$MnOg~",
  tokenizers: [ei, si, 0, 1, 2, 3],
  topRules: { Root: [0, 7], Nested: [1, 26] },
  dialects: { tags: 0 },
  tokenPrec: 573
});
function ii(r) {
  const t = [];
  let e = r.firstChild;
  for (; e; )
    t.push(e), e = e.nextSibling;
  return t;
}
const ri = (r, t) => {
  let e;
  try {
    e = _t.configure({
      strict: !0,
      top: t ? "Nested" : "Root",
      dialect: "tags"
    }).parse(r);
  } catch {
    return null;
  }
  const s = [], i = /* @__PURE__ */ new Map();
  function n($) {
    return r.substring($.from, $.to);
  }
  function o($) {
    const f = $.parent;
    let p = "", d;
    const S = [];
    ii($).forEach((z) => {
      const I = n(z);
      switch (z.type.id) {
        case Oe:
          p = I;
          break;
        case Ys:
          d = I;
          break;
        case Qs:
          S.push(I);
          break;
      }
    });
    const w = ["{", p];
    return d && (w.push(", "), w.push(d)), S.length && w.push(`, ${S.join(" ")}`), w.push("}"), {
      position: { start: f.from, end: f.to },
      type: "variable",
      name: p,
      normalizedValue: w.join("")
    };
  }
  function a($) {
    const f = $.firstChild, p = [hs, $s].includes(f.type.id), d = n(f), S = d.substring(p ? 1 : 2, d.length - 1).trim();
    return {
      position: { start: f.from, end: f.to },
      type: p ? "tagOpen" : "tagClose",
      name: S,
      normalizedValue: p ? `<${S}>` : `</${S}>`
    };
  }
  function l($) {
    if ($.type === "tagOpen") {
      const f = i.get($.name) ?? [];
      f.push($), i.set($.name, f);
    } else if ($.type === "tagClose") {
      const f = i.get($.name);
      f ? (f.pop(), f.length === 0 && i.delete($.name)) : $.error = "missing_open_tag";
    }
    s.push($);
  }
  const h = e.cursor();
  let u;
  do {
    const $ = h.node;
    switch ($.type.id) {
      case Zs:
        l({
          name: "#",
          type: "hash",
          position: { start: h.from, end: h.to },
          normalizedValue: "#"
        }), u = !1;
        break;
      case ge: {
        const f = $.firstChild.nextSibling;
        (f == null ? void 0 : f.type.id) === Xs && l(o(f)), u = !1;
        break;
      }
      case Ls:
      case Ms:
        l(a($)), u = !1;
        break;
      default:
        u = !0;
        break;
    }
  } while (h.next(u));
  return i.forEach(
    ($) => $.forEach((f) => {
      f.error = "missing_close_tag";
    })
  ), s;
};
class ni extends ks {
  constructor(t, e) {
    super(), this.value = t, this.examplePluralNum = e;
  }
  toDOM() {
    const t = document.createElement("span");
    let e = `placeholder-widget placeholder-${this.value.type}`;
    this.value.error && (e = e + ` placeholder-error placeholder-error-${this.value.error}`), t.className = e;
    const s = document.createElement("span");
    return s.textContent = this.value.type !== "hash" ? this.value.name : `#${this.examplePluralNum ?? ""}`, t.appendChild(s), t;
  }
}
function De(r, t, e) {
  const s = ri(r, e);
  return s === null ? null : s.filter((i) => {
    if (t) {
      const [n] = t;
      if (n > i.position.start && n < i.position.end)
        return !1;
    }
    return !0;
  });
}
function We(r, t) {
  const e = new ce();
  return r.forEach((s) => {
    e.add(
      s.position.start,
      s.position.end,
      Q.widget({
        widget: new ni(s, t),
        side: 1
      })
    );
  }), e.finish();
}
function oi(r, t) {
  return t.find((e) => e.name === r.name && e.type === e.type);
}
function ai(r, t) {
  return t.find(
    (e) => e.name === r.name && e.type === r.type && e.position.start === e.position.start && e.position.end === e.position.end
  );
}
function li(r, t, e) {
  return t.filter((s) => !!(ai(s, r) || oi(s, e)));
}
function hi(r, t, e, s, i) {
  const n = e - t, a = i - s - n;
  return r.filter((l) => t < l.position.end && e > l.position.start ? !1 : (e < l.position.start && (l.position.start += a, l.position.end += a), !0));
}
function Zt(r, t) {
  let e = r;
  return t.iterChanges((s, i, n, o) => {
    e = hi(e, s, i, n, o);
  }), e;
}
const Ki = (r) => {
  const { noUpdates: t, allowedNewPlaceholders: e, nested: s } = r;
  return es.define({
    create(i) {
      try {
        return De(i.doc.toString(), void 0, s) || [];
      } catch {
        return [];
      }
    },
    update(i, n) {
      if (t)
        return Zt(i, n.changes);
      if (n.docChanged && !t) {
        let o;
        n.changes.iterChanges((l, h, u, $) => {
          const f = h - l;
          $ - u - f <= 1 && (o = [u, $]);
        });
        const a = De(
          n.state.doc.toString(),
          o,
          s
        );
        return a === null ? Zt(i, n.changes) : e ? li(
          i,
          Zt(i, n.changes),
          e
        ) : a;
      }
      return i;
    },
    provide(i) {
      return Bt.fromClass(
        class {
          constructor(n) {
            bt(this, "decorationSet");
            this.decorationSet = We(
              n.state.field(i),
              r == null ? void 0 : r.examplePluralNum
            );
          }
          update(n) {
            this.decorationSet = We(
              n.state.field(i),
              r == null ? void 0 : r.examplePluralNum
            );
          }
        },
        {
          decorations: (n) => n.decorationSet,
          provide: (n) => at.atomicRanges.of((o) => {
            var a;
            return ((a = o.plugin(n)) == null ? void 0 : a.decorationSet) || Q.none;
          })
        }
      );
    }
  });
};
let $i = 0;
class Y {
  /**
  @internal
  */
  constructor(t, e, s) {
    this.set = t, this.base = e, this.modified = s, this.id = $i++;
  }
  /**
  Define a new tag. If `parent` is given, the tag is treated as a
  sub-tag of that parent, and
  [highlighters](#highlight.tagHighlighter) that don't mention
  this tag will try to fall back to the parent tag (or grandparent
  tag, etc).
  */
  static define(t) {
    if (t != null && t.base)
      throw new Error("Can not derive from a modified tag");
    let e = new Y([], null, []);
    if (e.set.push(e), t)
      for (let s of t.set)
        e.set.push(s);
    return e;
  }
  /**
  Define a tag _modifier_, which is a function that, given a tag,
  will return a tag that is a subtag of the original. Applying the
  same modifier to a twice tag will return the same value (`m1(t1)
  == m1(t1)`) and applying multiple modifiers will, regardless or
  order, produce the same tag (`m1(m2(t1)) == m2(m1(t1))`).
  
  When multiple modifiers are applied to a given base tag, each
  smaller set of modifiers is registered as a parent, so that for
  example `m1(m2(m3(t1)))` is a subtype of `m1(m2(t1))`,
  `m1(m3(t1)`, and so on.
  */
  static defineModifier() {
    let t = new qt();
    return (e) => e.modified.indexOf(t) > -1 ? e : qt.get(e.base || e, e.modified.concat(t).sort((s, i) => s.id - i.id));
  }
}
let ui = 0;
class qt {
  constructor() {
    this.instances = [], this.id = ui++;
  }
  static get(t, e) {
    if (!e.length)
      return t;
    let s = e[0].instances.find((a) => a.base == t && fi(e, a.modified));
    if (s)
      return s;
    let i = [], n = new Y(i, t, e);
    for (let a of e)
      a.instances.push(n);
    let o = ci(e);
    for (let a of t.set)
      if (!a.modified.length)
        for (let l of o)
          i.push(qt.get(a, l));
    return n;
  }
}
function fi(r, t) {
  return r.length == t.length && r.every((e, s) => e == t[s]);
}
function ci(r) {
  let t = [[]];
  for (let e = 0; e < r.length; e++)
    for (let s = 0, i = t.length; s < i; s++)
      t.push(t[s].concat(r[e]));
  return t.sort((e, s) => s.length - e.length);
}
function Us(r) {
  let t = /* @__PURE__ */ Object.create(null);
  for (let e in r) {
    let s = r[e];
    Array.isArray(s) || (s = [s]);
    for (let i of e.split(" "))
      if (i) {
        let n = [], o = 2, a = i;
        for (let $ = 0; ; ) {
          if (a == "..." && $ > 0 && $ + 3 == i.length) {
            o = 1;
            break;
          }
          let f = /^"(?:[^"\\]|\\.)*?"|[^\/!]+/.exec(a);
          if (!f)
            throw new RangeError("Invalid path: " + i);
          if (n.push(f[0] == "*" ? "" : f[0][0] == '"' ? JSON.parse(f[0]) : f[0]), $ += f[0].length, $ == i.length)
            break;
          let p = i[$++];
          if ($ == i.length && p == "!") {
            o = 0;
            break;
          }
          if (p != "/")
            throw new RangeError("Invalid path: " + i);
          a = i.slice($);
        }
        let l = n.length - 1, h = n[l];
        if (!h)
          throw new RangeError("Invalid path: " + i);
        let u = new Nt(s, o, l > 0 ? n.slice(0, l) : null);
        t[h] = u.sort(t[h]);
      }
  }
  return js.add(t);
}
const js = new b();
class Nt {
  constructor(t, e, s, i) {
    this.tags = t, this.mode = e, this.context = s, this.next = i;
  }
  get opaque() {
    return this.mode == 0;
  }
  get inherit() {
    return this.mode == 1;
  }
  sort(t) {
    return !t || t.depth < this.depth ? (this.next = t, this) : (t.next = this.sort(t.next), t);
  }
  get depth() {
    return this.context ? this.context.length : 0;
  }
}
Nt.empty = new Nt([], 2, null);
function gs(r, t) {
  let e = /* @__PURE__ */ Object.create(null);
  for (let n of r)
    if (!Array.isArray(n.tag))
      e[n.tag.id] = n.class;
    else
      for (let o of n.tag)
        e[o.id] = n.class;
  let { scope: s, all: i = null } = t || {};
  return {
    style: (n) => {
      let o = i;
      for (let a of n)
        for (let l of a.set) {
          let h = e[l.id];
          if (h) {
            o = o ? o + " " + h : h;
            break;
          }
        }
      return o;
    },
    scope: s
  };
}
function pi(r, t) {
  let e = null;
  for (let s of r) {
    let i = s.style(t);
    i && (e = e ? e + " " + i : i);
  }
  return e;
}
function di(r, t, e, s = 0, i = r.length) {
  let n = new Ui(s, Array.isArray(t) ? t : [t], e);
  n.highlightRange(r.cursor(), s, i, "", n.highlighters), n.flush(i);
}
class Ui {
  constructor(t, e, s) {
    this.at = t, this.highlighters = e, this.span = s, this.class = "";
  }
  startSpan(t, e) {
    e != this.class && (this.flush(t), t > this.at && (this.at = t), this.class = e);
  }
  flush(t) {
    t > this.at && this.class && this.span(this.at, t, this.class);
  }
  highlightRange(t, e, s, i, n) {
    let { type: o, from: a, to: l } = t;
    if (a >= s || l <= e)
      return;
    o.isTop && (n = this.highlighters.filter((p) => !p.scope || p.scope(o)));
    let h = i, u = ji(t) || Nt.empty, $ = pi(n, u.tags);
    if ($ && (h && (h += " "), h += $, u.mode == 1 && (i += (i ? " " : "") + $)), this.startSpan(Math.max(e, a), h), u.opaque)
      return;
    let f = t.tree && t.tree.prop(b.mounted);
    if (f && f.overlay) {
      let p = t.node.enter(f.overlay[0].from + a, 1), d = this.highlighters.filter((w) => !w.scope || w.scope(f.tree.type)), S = t.firstChild();
      for (let w = 0, z = a; ; w++) {
        let I = w < f.overlay.length ? f.overlay[w] : null, v = I ? I.from + a : l, E = Math.max(e, z), m = Math.min(s, v);
        if (E < m && S)
          for (; t.from < m && (this.highlightRange(t, E, m, i, n), this.startSpan(Math.min(m, t.to), h), !(t.to >= v || !t.nextSibling())); )
            ;
        if (!I || v > s)
          break;
        z = I.to + a, z > e && (this.highlightRange(p.cursor(), Math.max(e, I.from + a), Math.min(s, z), "", d), this.startSpan(Math.min(s, z), h));
      }
      S && t.parent();
    } else if (t.firstChild()) {
      f && (i = "");
      do
        if (!(t.to <= e)) {
          if (t.from >= s)
            break;
          this.highlightRange(t, e, s, i, n), this.startSpan(Math.min(s, t.to), h);
        }
      while (t.nextSibling());
      t.parent();
    }
  }
}
function ji(r) {
  let t = r.type.prop(js);
  for (; t && t.context && !r.matchContext(t.context); )
    t = t.next;
  return t || null;
}
const c = Y.define, yt = c(), M = c(), Pe = c(M), Ce = c(M), H = c(), wt = c(H), Lt = c(H), X = c(), nt = c(X), A = c(), B = c(), le = c(), Ut = c(le), Tt = c(), U = {
  /**
  A comment.
  */
  comment: yt,
  /**
  A line [comment](#highlight.tags.comment).
  */
  lineComment: c(yt),
  /**
  A block [comment](#highlight.tags.comment).
  */
  blockComment: c(yt),
  /**
  A documentation [comment](#highlight.tags.comment).
  */
  docComment: c(yt),
  /**
  Any kind of identifier.
  */
  name: M,
  /**
  The [name](#highlight.tags.name) of a variable.
  */
  variableName: c(M),
  /**
  A type [name](#highlight.tags.name).
  */
  typeName: Pe,
  /**
  A tag name (subtag of [`typeName`](#highlight.tags.typeName)).
  */
  tagName: c(Pe),
  /**
  A property or field [name](#highlight.tags.name).
  */
  propertyName: Ce,
  /**
  An attribute name (subtag of [`propertyName`](#highlight.tags.propertyName)).
  */
  attributeName: c(Ce),
  /**
  The [name](#highlight.tags.name) of a class.
  */
  className: c(M),
  /**
  A label [name](#highlight.tags.name).
  */
  labelName: c(M),
  /**
  A namespace [name](#highlight.tags.name).
  */
  namespace: c(M),
  /**
  The [name](#highlight.tags.name) of a macro.
  */
  macroName: c(M),
  /**
  A literal value.
  */
  literal: H,
  /**
  A string [literal](#highlight.tags.literal).
  */
  string: wt,
  /**
  A documentation [string](#highlight.tags.string).
  */
  docString: c(wt),
  /**
  A character literal (subtag of [string](#highlight.tags.string)).
  */
  character: c(wt),
  /**
  An attribute value (subtag of [string](#highlight.tags.string)).
  */
  attributeValue: c(wt),
  /**
  A number [literal](#highlight.tags.literal).
  */
  number: Lt,
  /**
  An integer [number](#highlight.tags.number) literal.
  */
  integer: c(Lt),
  /**
  A floating-point [number](#highlight.tags.number) literal.
  */
  float: c(Lt),
  /**
  A boolean [literal](#highlight.tags.literal).
  */
  bool: c(H),
  /**
  Regular expression [literal](#highlight.tags.literal).
  */
  regexp: c(H),
  /**
  An escape [literal](#highlight.tags.literal), for example a
  backslash escape in a string.
  */
  escape: c(H),
  /**
  A color [literal](#highlight.tags.literal).
  */
  color: c(H),
  /**
  A URL [literal](#highlight.tags.literal).
  */
  url: c(H),
  /**
  A language keyword.
  */
  keyword: A,
  /**
  The [keyword](#highlight.tags.keyword) for the self or this
  object.
  */
  self: c(A),
  /**
  The [keyword](#highlight.tags.keyword) for null.
  */
  null: c(A),
  /**
  A [keyword](#highlight.tags.keyword) denoting some atomic value.
  */
  atom: c(A),
  /**
  A [keyword](#highlight.tags.keyword) that represents a unit.
  */
  unit: c(A),
  /**
  A modifier [keyword](#highlight.tags.keyword).
  */
  modifier: c(A),
  /**
  A [keyword](#highlight.tags.keyword) that acts as an operator.
  */
  operatorKeyword: c(A),
  /**
  A control-flow related [keyword](#highlight.tags.keyword).
  */
  controlKeyword: c(A),
  /**
  A [keyword](#highlight.tags.keyword) that defines something.
  */
  definitionKeyword: c(A),
  /**
  A [keyword](#highlight.tags.keyword) related to defining or
  interfacing with modules.
  */
  moduleKeyword: c(A),
  /**
  An operator.
  */
  operator: B,
  /**
  An [operator](#highlight.tags.operator) that dereferences something.
  */
  derefOperator: c(B),
  /**
  Arithmetic-related [operator](#highlight.tags.operator).
  */
  arithmeticOperator: c(B),
  /**
  Logical [operator](#highlight.tags.operator).
  */
  logicOperator: c(B),
  /**
  Bit [operator](#highlight.tags.operator).
  */
  bitwiseOperator: c(B),
  /**
  Comparison [operator](#highlight.tags.operator).
  */
  compareOperator: c(B),
  /**
  [Operator](#highlight.tags.operator) that updates its operand.
  */
  updateOperator: c(B),
  /**
  [Operator](#highlight.tags.operator) that defines something.
  */
  definitionOperator: c(B),
  /**
  Type-related [operator](#highlight.tags.operator).
  */
  typeOperator: c(B),
  /**
  Control-flow [operator](#highlight.tags.operator).
  */
  controlOperator: c(B),
  /**
  Program or markup punctuation.
  */
  punctuation: le,
  /**
  [Punctuation](#highlight.tags.punctuation) that separates
  things.
  */
  separator: c(le),
  /**
  Bracket-style [punctuation](#highlight.tags.punctuation).
  */
  bracket: Ut,
  /**
  Angle [brackets](#highlight.tags.bracket) (usually `<` and `>`
  tokens).
  */
  angleBracket: c(Ut),
  /**
  Square [brackets](#highlight.tags.bracket) (usually `[` and `]`
  tokens).
  */
  squareBracket: c(Ut),
  /**
  Parentheses (usually `(` and `)` tokens). Subtag of
  [bracket](#highlight.tags.bracket).
  */
  paren: c(Ut),
  /**
  Braces (usually `{` and `}` tokens). Subtag of
  [bracket](#highlight.tags.bracket).
  */
  brace: c(Ut),
  /**
  Content, for example plain text in XML or markup documents.
  */
  content: X,
  /**
  [Content](#highlight.tags.content) that represents a heading.
  */
  heading: nt,
  /**
  A level 1 [heading](#highlight.tags.heading).
  */
  heading1: c(nt),
  /**
  A level 2 [heading](#highlight.tags.heading).
  */
  heading2: c(nt),
  /**
  A level 3 [heading](#highlight.tags.heading).
  */
  heading3: c(nt),
  /**
  A level 4 [heading](#highlight.tags.heading).
  */
  heading4: c(nt),
  /**
  A level 5 [heading](#highlight.tags.heading).
  */
  heading5: c(nt),
  /**
  A level 6 [heading](#highlight.tags.heading).
  */
  heading6: c(nt),
  /**
  A prose separator (such as a horizontal rule).
  */
  contentSeparator: c(X),
  /**
  [Content](#highlight.tags.content) that represents a list.
  */
  list: c(X),
  /**
  [Content](#highlight.tags.content) that represents a quote.
  */
  quote: c(X),
  /**
  [Content](#highlight.tags.content) that is emphasized.
  */
  emphasis: c(X),
  /**
  [Content](#highlight.tags.content) that is styled strong.
  */
  strong: c(X),
  /**
  [Content](#highlight.tags.content) that is part of a link.
  */
  link: c(X),
  /**
  [Content](#highlight.tags.content) that is styled as code or
  monospace.
  */
  monospace: c(X),
  /**
  [Content](#highlight.tags.content) that has a strike-through
  style.
  */
  strikethrough: c(X),
  /**
  Inserted text in a change-tracking format.
  */
  inserted: c(),
  /**
  Deleted text.
  */
  deleted: c(),
  /**
  Changed text.
  */
  changed: c(),
  /**
  An invalid or unsyntactic element.
  */
  invalid: c(),
  /**
  Metadata or meta-instruction.
  */
  meta: Tt,
  /**
  [Metadata](#highlight.tags.meta) that applies to the entire
  document.
  */
  documentMeta: c(Tt),
  /**
  [Metadata](#highlight.tags.meta) that annotates or adds
  attributes to a given syntactic element.
  */
  annotation: c(Tt),
  /**
  Processing instruction or preprocessor directive. Subtag of
  [meta](#highlight.tags.meta).
  */
  processingInstruction: c(Tt),
  /**
  [Modifier](#highlight.Tag^defineModifier) that indicates that a
  given element is being defined. Expected to be used with the
  various [name](#highlight.tags.name) tags.
  */
  definition: Y.defineModifier(),
  /**
  [Modifier](#highlight.Tag^defineModifier) that indicates that
  something is constant. Mostly expected to be used with
  [variable names](#highlight.tags.variableName).
  */
  constant: Y.defineModifier(),
  /**
  [Modifier](#highlight.Tag^defineModifier) used to indicate that
  a [variable](#highlight.tags.variableName) or [property
  name](#highlight.tags.propertyName) is being called or defined
  as a function.
  */
  function: Y.defineModifier(),
  /**
  [Modifier](#highlight.Tag^defineModifier) that can be applied to
  [names](#highlight.tags.name) to indicate that they belong to
  the language's standard environment.
  */
  standard: Y.defineModifier(),
  /**
  [Modifier](#highlight.Tag^defineModifier) that indicates a given
  [names](#highlight.tags.name) is local to some scope.
  */
  local: Y.defineModifier(),
  /**
  A generic variant [modifier](#highlight.Tag^defineModifier) that
  can be used to tag language-specific alternative variants of
  some common tag. It is recommended for themes to define special
  forms of at least the [string](#highlight.tags.string) and
  [variable name](#highlight.tags.variableName) tags, since those
  come up a lot.
  */
  special: Y.defineModifier()
};
gs([
  { tag: U.link, class: "tok-link" },
  { tag: U.heading, class: "tok-heading" },
  { tag: U.emphasis, class: "tok-emphasis" },
  { tag: U.strong, class: "tok-strong" },
  { tag: U.keyword, class: "tok-keyword" },
  { tag: U.atom, class: "tok-atom" },
  { tag: U.bool, class: "tok-bool" },
  { tag: U.url, class: "tok-url" },
  { tag: U.labelName, class: "tok-labelName" },
  { tag: U.inserted, class: "tok-inserted" },
  { tag: U.deleted, class: "tok-deleted" },
  { tag: U.literal, class: "tok-literal" },
  { tag: U.string, class: "tok-string" },
  { tag: U.number, class: "tok-number" },
  { tag: [U.regexp, U.escape, U.special(U.string)], class: "tok-string2" },
  { tag: U.variableName, class: "tok-variableName" },
  { tag: U.local(U.variableName), class: "tok-variableName tok-local" },
  { tag: U.definition(U.variableName), class: "tok-variableName tok-definition" },
  { tag: U.special(U.variableName), class: "tok-variableName2" },
  { tag: U.definition(U.propertyName), class: "tok-propertyName tok-definition" },
  { tag: U.typeName, class: "tok-typeName" },
  { tag: U.namespace, class: "tok-namespace" },
  { tag: U.className, class: "tok-className" },
  { tag: U.macroName, class: "tok-macroName" },
  { tag: U.propertyName, class: "tok-propertyName" },
  { tag: U.operator, class: "tok-operator" },
  { tag: U.comment, class: "tok-comment" },
  { tag: U.meta, class: "tok-meta" },
  { tag: U.invalid, class: "tok-invalid" },
  { tag: U.punctuation, class: "tok-punctuation" }
]);
const he = "ͼ", qe = typeof Symbol > "u" ? "__" + he : Symbol.for(he), $e = typeof Symbol > "u" ? "__styleSet" + Math.floor(Math.random() * 1e8) : Symbol("styleSet"), Ne = typeof globalThis < "u" ? globalThis : typeof window < "u" ? window : {};
class Ee {
  // :: (Object<Style>, ?{finish: ?(string) → string})
  // Create a style module from the given spec.
  //
  // When `finish` is given, it is called on regular (non-`@`)
  // selectors (after `&` expansion) to compute the final selector.
  constructor(t, e) {
    this.rules = [];
    let { finish: s } = e || {};
    function i(o) {
      return /^@/.test(o) ? [o] : o.split(/,\s*/);
    }
    function n(o, a, l, h) {
      let u = [], $ = /^@(\w+)\b/.exec(o[0]), f = $ && $[1] == "keyframes";
      if ($ && a == null)
        return l.push(o[0] + ";");
      for (let p in a) {
        let d = a[p];
        if (/&/.test(p))
          n(
            p.split(/,\s*/).map((S) => o.map((w) => S.replace(/&/, w))).reduce((S, w) => S.concat(w)),
            d,
            l
          );
        else if (d && typeof d == "object") {
          if (!$)
            throw new RangeError("The value of a property (" + p + ") should be a primitive value.");
          n(i(p), d, u, f);
        } else
          d != null && u.push(p.replace(/_.*/, "").replace(/[A-Z]/g, (S) => "-" + S.toLowerCase()) + ": " + d + ";");
      }
      (u.length || f) && l.push((s && !$ && !h ? o.map(s) : o).join(", ") + " {" + u.join(" ") + "}");
    }
    for (let o in t)
      n(i(o), t[o], this.rules);
  }
  // :: () → string
  // Returns a string containing the module's CSS rules.
  getRules() {
    return this.rules.join(`
`);
  }
  // :: () → string
  // Generate a new unique CSS class name.
  static newName() {
    let t = Ne[qe] || 1;
    return Ne[qe] = t + 1, he + t.toString(36);
  }
  // :: (union<Document, ShadowRoot>, union<[StyleModule], StyleModule>, ?{nonce: ?string})
  //
  // Mount the given set of modules in the given DOM root, which ensures
  // that the CSS rules defined by the module are available in that
  // context.
  //
  // Rules are only added to the document once per root.
  //
  // Rule order will follow the order of the modules, so that rules from
  // modules later in the array take precedence of those from earlier
  // modules. If you call this function multiple times for the same root
  // in a way that changes the order of already mounted modules, the old
  // order will be changed.
  //
  // If a Content Security Policy nonce is provided, it is added to
  // the `<style>` tag generated by the library.
  static mount(t, e, s) {
    let i = t[$e], n = s && s.nonce;
    i ? n && i.setNonce(n) : i = new gi(t, n), i.mount(Array.isArray(e) ? e : [e]);
  }
}
let Ge = /* @__PURE__ */ new Map();
class gi {
  constructor(t, e) {
    let s = t.ownerDocument || t, i = s.defaultView;
    if (!t.head && t.adoptedStyleSheets && i.CSSStyleSheet) {
      let n = Ge.get(s);
      if (n)
        return t.adoptedStyleSheets = [n.sheet, ...t.adoptedStyleSheets], t[$e] = n;
      this.sheet = new i.CSSStyleSheet(), t.adoptedStyleSheets = [this.sheet, ...t.adoptedStyleSheets], Ge.set(s, this);
    } else {
      this.styleTag = s.createElement("style"), e && this.styleTag.setAttribute("nonce", e);
      let n = t.head || t;
      n.insertBefore(this.styleTag, n.firstChild);
    }
    this.modules = [], t[$e] = this;
  }
  mount(t) {
    let e = this.sheet, s = 0, i = 0;
    for (let n = 0; n < t.length; n++) {
      let o = t[n], a = this.modules.indexOf(o);
      if (a < i && a > -1 && (this.modules.splice(a, 1), i--, a = -1), a == -1) {
        if (this.modules.splice(i++, 0, o), e)
          for (let l = 0; l < o.rules.length; l++)
            e.insertRule(o.rules[l], s++);
      } else {
        for (; i < a; )
          s += this.modules[i++].rules.length;
        s += o.rules.length, i++;
      }
    }
    if (!e) {
      let n = "";
      for (let o = 0; o < this.modules.length; o++)
        n += this.modules[o].getRules() + `
`;
      this.styleTag.textContent = n;
    }
  }
  setNonce(t) {
    this.styleTag && this.styleTag.getAttribute("nonce") != t && this.styleTag.setAttribute("nonce", t);
  }
}
var Mt;
const ft = /* @__PURE__ */ new b();
function Oi(r) {
  return At.define({
    combine: r ? (t) => t.concat(r) : void 0
  });
}
const Si = /* @__PURE__ */ new b();
class N {
  /**
  Construct a language object. If you need to invoke this
  directly, first define a data facet with
  [`defineLanguageFacet`](https://codemirror.net/6/docs/ref/#language.defineLanguageFacet), and then
  configure your parser to [attach](https://codemirror.net/6/docs/ref/#language.languageDataProp) it
  to the language's outer syntax node.
  */
  constructor(t, e, s = [], i = "") {
    this.data = t, this.name = i, Yt.prototype.hasOwnProperty("tree") || Object.defineProperty(Yt.prototype, "tree", { get() {
      return L(this);
    } }), this.parser = e, this.extension = [
      dt.of(this),
      Yt.languageData.of((n, o, a) => {
        let l = Ae(n, o, a), h = l.type.prop(ft);
        if (!h)
          return [];
        let u = n.facet(h), $ = l.type.prop(Si);
        if ($) {
          let f = l.resolve(o - l.from, a);
          for (let p of $)
            if (p.test(f, n)) {
              let d = n.facet(p.facet);
              return p.type == "replace" ? d : d.concat(u);
            }
        }
        return u;
      })
    ].concat(s);
  }
  /**
  Query whether this language is active at the given position.
  */
  isActiveAt(t, e, s = -1) {
    return Ae(t, e, s).type.prop(ft) == this.data;
  }
  /**
  Find the document regions that were parsed using this language.
  The returned regions will _include_ any nested languages rooted
  in this language, when those exist.
  */
  findRegions(t) {
    let e = t.facet(dt);
    if ((e == null ? void 0 : e.data) == this.data)
      return [{ from: 0, to: t.doc.length }];
    if (!e || !e.allowsNesting)
      return [];
    let s = [], i = (n, o) => {
      if (n.prop(ft) == this.data) {
        s.push({ from: o, to: o + n.length });
        return;
      }
      let a = n.prop(b.mounted);
      if (a) {
        if (a.tree.prop(ft) == this.data) {
          if (a.overlay)
            for (let l of a.overlay)
              s.push({ from: l.from + o, to: l.to + o });
          else
            s.push({ from: o, to: o + n.length });
          return;
        } else if (a.overlay) {
          let l = s.length;
          if (i(a.tree, a.overlay[0].from + o), s.length > l)
            return;
        }
      }
      for (let l = 0; l < n.children.length; l++) {
        let h = n.children[l];
        h instanceof R && i(h, n.positions[l] + o);
      }
    };
    return i(L(t), 0), s;
  }
  /**
  Indicates whether this language allows nested languages. The
  default implementation returns true.
  */
  get allowsNesting() {
    return !0;
  }
}
N.setState = /* @__PURE__ */ bs.define();
function Ae(r, t, e) {
  let s = r.facet(dt), i = L(r).topNode;
  if (!s || s.allowsNesting)
    for (let n = i; n; n = n.enter(t, e, V.ExcludeBuffers))
      n.type.isTop && (i = n);
  return i;
}
class Et extends N {
  constructor(t, e, s) {
    super(t, e, [], s), this.parser = e;
  }
  /**
  Define a language from a parser.
  */
  static define(t) {
    let e = Oi(t.languageData);
    return new Et(e, t.parser.configure({
      props: [ft.add((s) => s.isTop ? e : void 0)]
    }), t.name);
  }
  /**
  Create a new instance of this language with a reconfigured
  version of its parser and optionally a new name.
  */
  configure(t, e) {
    return new Et(this.data, this.parser.configure(t), e || this.name);
  }
  get allowsNesting() {
    return this.parser.hasWrappers();
  }
}
function L(r) {
  let t = r.field(N.state, !1);
  return t ? t.tree : R.empty;
}
class mi {
  /**
  Create an input object for the given document.
  */
  constructor(t) {
    this.doc = t, this.cursorPos = 0, this.string = "", this.cursor = t.iter();
  }
  get length() {
    return this.doc.length;
  }
  syncTo(t) {
    return this.string = this.cursor.next(t - this.cursorPos).value, this.cursorPos = t + this.string.length, this.cursorPos - this.string.length;
  }
  chunk(t) {
    return this.syncTo(t), this.string;
  }
  get lineChunks() {
    return !0;
  }
  read(t, e) {
    let s = this.cursorPos - this.string.length;
    return t < s || e >= this.cursorPos ? this.doc.sliceString(t, e) : this.string.slice(t - s, e - s);
  }
}
let jt = null;
class Gt {
  constructor(t, e, s = [], i, n, o, a, l) {
    this.parser = t, this.state = e, this.fragments = s, this.tree = i, this.treeLen = n, this.viewport = o, this.skipped = a, this.scheduleOn = l, this.parse = null, this.tempSkipped = [];
  }
  /**
  @internal
  */
  static create(t, e, s) {
    return new Gt(t, e, [], R.empty, 0, s, [], null);
  }
  startParse() {
    return this.parser.startParse(new mi(this.state.doc), this.fragments);
  }
  /**
  @internal
  */
  work(t, e) {
    return e != null && e >= this.state.doc.length && (e = void 0), this.tree != R.empty && this.isDone(e ?? this.state.doc.length) ? (this.takeTree(), !0) : this.withContext(() => {
      var s;
      if (typeof t == "number") {
        let i = Date.now() + t;
        t = () => Date.now() > i;
      }
      for (this.parse || (this.parse = this.startParse()), e != null && (this.parse.stoppedAt == null || this.parse.stoppedAt > e) && e < this.state.doc.length && this.parse.stopAt(e); ; ) {
        let i = this.parse.advance();
        if (i)
          if (this.fragments = this.withoutTempSkipped(lt.addTree(i, this.fragments, this.parse.stoppedAt != null)), this.treeLen = (s = this.parse.stoppedAt) !== null && s !== void 0 ? s : this.state.doc.length, this.tree = i, this.parse = null, this.treeLen < (e ?? this.state.doc.length))
            this.parse = this.startParse();
          else
            return !0;
        if (t())
          return !1;
      }
    });
  }
  /**
  @internal
  */
  takeTree() {
    let t, e;
    this.parse && (t = this.parse.parsedPos) >= this.treeLen && ((this.parse.stoppedAt == null || this.parse.stoppedAt > t) && this.parse.stopAt(t), this.withContext(() => {
      for (; !(e = this.parse.advance()); )
        ;
    }), this.treeLen = t, this.tree = e, this.fragments = this.withoutTempSkipped(lt.addTree(this.tree, this.fragments, !0)), this.parse = null);
  }
  withContext(t) {
    let e = jt;
    jt = this;
    try {
      return t();
    } finally {
      jt = e;
    }
  }
  withoutTempSkipped(t) {
    for (let e; e = this.tempSkipped.pop(); )
      t = Be(t, e.from, e.to);
    return t;
  }
  /**
  @internal
  */
  changes(t, e) {
    let { fragments: s, tree: i, treeLen: n, viewport: o, skipped: a } = this;
    if (this.takeTree(), !t.empty) {
      let l = [];
      if (t.iterChangedRanges((h, u, $, f) => l.push({ fromA: h, toA: u, fromB: $, toB: f })), s = lt.applyChanges(s, l), i = R.empty, n = 0, o = { from: t.mapPos(o.from, -1), to: t.mapPos(o.to, 1) }, this.skipped.length) {
        a = [];
        for (let h of this.skipped) {
          let u = t.mapPos(h.from, 1), $ = t.mapPos(h.to, -1);
          u < $ && a.push({ from: u, to: $ });
        }
      }
    }
    return new Gt(this.parser, e, s, i, n, o, a, this.scheduleOn);
  }
  /**
  @internal
  */
  updateViewport(t) {
    if (this.viewport.from == t.from && this.viewport.to == t.to)
      return !1;
    this.viewport = t;
    let e = this.skipped.length;
    for (let s = 0; s < this.skipped.length; s++) {
      let { from: i, to: n } = this.skipped[s];
      i < t.to && n > t.from && (this.fragments = Be(this.fragments, i, n), this.skipped.splice(s--, 1));
    }
    return this.skipped.length >= e ? !1 : (this.reset(), !0);
  }
  /**
  @internal
  */
  reset() {
    this.parse && (this.takeTree(), this.parse = null);
  }
  /**
  Notify the parse scheduler that the given region was skipped
  because it wasn't in view, and the parse should be restarted
  when it comes into view.
  */
  skipUntilInView(t, e) {
    this.skipped.push({ from: t, to: e });
  }
  /**
  Returns a parser intended to be used as placeholder when
  asynchronously loading a nested parser. It'll skip its input and
  mark it as not-really-parsed, so that the next update will parse
  it again.
  
  When `until` is given, a reparse will be scheduled when that
  promise resolves.
  */
  static getSkippingParser(t) {
    return new class extends as {
      createParse(e, s, i) {
        let n = i[0].from, o = i[i.length - 1].to;
        return {
          parsedPos: n,
          advance() {
            let l = jt;
            if (l) {
              for (let h of i)
                l.tempSkipped.push(h);
              t && (l.scheduleOn = l.scheduleOn ? Promise.all([l.scheduleOn, t]) : t);
            }
            return this.parsedPos = o, new R(W.none, [], [], o - n);
          },
          stoppedAt: null,
          stopAt() {
          }
        };
      }
    }();
  }
  /**
  @internal
  */
  isDone(t) {
    t = Math.min(t, this.state.doc.length);
    let e = this.fragments;
    return this.treeLen >= t && e.length && e[0].from == 0 && e[0].to >= t;
  }
  /**
  Get the context for the current parse, or `null` if no editor
  parse is in progress.
  */
  static get() {
    return jt;
  }
}
function Be(r, t, e) {
  return lt.applyChanges(r, [{ fromA: t, toA: e, fromB: t, toB: e }]);
}
class pt {
  constructor(t) {
    this.context = t, this.tree = t.tree;
  }
  apply(t) {
    if (!t.docChanged && this.tree == this.context.tree)
      return this;
    let e = this.context.changes(t.changes, t.state), s = this.context.treeLen == t.startState.doc.length ? void 0 : Math.max(t.changes.mapPos(this.context.treeLen), e.viewport.to);
    return e.work(20, s) || e.takeTree(), new pt(e);
  }
  static init(t) {
    let e = Math.min(3e3, t.doc.length), s = Gt.create(t.facet(dt).parser, t, { from: 0, to: e });
    return s.work(20, e) || s.takeTree(), new pt(s);
  }
}
N.state = /* @__PURE__ */ es.define({
  create: pt.init,
  update(r, t) {
    for (let e of t.effects)
      if (e.is(N.setState))
        return e.value;
    return t.startState.facet(dt) != t.state.facet(dt) ? pt.init(t.state) : r.apply(t);
  }
});
let Os = (r) => {
  let t = setTimeout(
    () => r(),
    500
    /* Work.MaxPause */
  );
  return () => clearTimeout(t);
};
typeof requestIdleCallback < "u" && (Os = (r) => {
  let t = -1, e = setTimeout(
    () => {
      t = requestIdleCallback(r, {
        timeout: 400
        /* Work.MinPause */
      });
    },
    100
    /* Work.MinPause */
  );
  return () => t < 0 ? clearTimeout(e) : cancelIdleCallback(t);
});
const Ht = typeof navigator < "u" && (!((Mt = navigator.scheduling) === null || Mt === void 0) && Mt.isInputPending) ? () => navigator.scheduling.isInputPending() : null, xi = /* @__PURE__ */ Bt.fromClass(class {
  constructor(t) {
    this.view = t, this.working = null, this.workScheduled = 0, this.chunkEnd = -1, this.chunkBudget = -1, this.work = this.work.bind(this), this.scheduleWork();
  }
  update(t) {
    let e = this.view.state.field(N.state).context;
    (e.updateViewport(t.view.viewport) || this.view.viewport.to > e.treeLen) && this.scheduleWork(), (t.docChanged || t.selectionSet) && (this.view.hasFocus && (this.chunkBudget += 50), this.scheduleWork()), this.checkAsyncSchedule(e);
  }
  scheduleWork() {
    if (this.working)
      return;
    let { state: t } = this.view, e = t.field(N.state);
    (e.tree != e.context.tree || !e.context.isDone(t.doc.length)) && (this.working = Os(this.work));
  }
  work(t) {
    this.working = null;
    let e = Date.now();
    if (this.chunkEnd < e && (this.chunkEnd < 0 || this.view.hasFocus) && (this.chunkEnd = e + 3e4, this.chunkBudget = 3e3), this.chunkBudget <= 0)
      return;
    let { state: s, viewport: { to: i } } = this.view, n = s.field(N.state);
    if (n.tree == n.context.tree && n.context.isDone(
      i + 1e5
      /* Work.MaxParseAhead */
    ))
      return;
    let o = Date.now() + Math.min(this.chunkBudget, 100, t && !Ht ? Math.max(25, t.timeRemaining() - 5) : 1e9), a = n.context.treeLen < i && s.doc.length > i + 1e3, l = n.context.work(() => Ht && Ht() || Date.now() > o, i + (a ? 0 : 1e5));
    this.chunkBudget -= Date.now() - e, (l || this.chunkBudget <= 0) && (n.context.takeTree(), this.view.dispatch({ effects: N.setState.of(new pt(n.context)) })), this.chunkBudget > 0 && !(l && !a) && this.scheduleWork(), this.checkAsyncSchedule(n.context);
  }
  checkAsyncSchedule(t) {
    t.scheduleOn && (this.workScheduled++, t.scheduleOn.then(() => this.scheduleWork()).catch((e) => Js(this.view.state, e)).then(() => this.workScheduled--), t.scheduleOn = null);
  }
  destroy() {
    this.working && this.working();
  }
  isWorking() {
    return !!(this.working || this.workScheduled > 0);
  }
}, {
  eventHandlers: { focus() {
    this.scheduleWork();
  } }
}), dt = /* @__PURE__ */ At.define({
  combine(r) {
    return r.length ? r[0] : null;
  },
  enables: (r) => [
    N.state,
    xi,
    at.contentAttributes.compute([r], (t) => {
      let e = t.facet(r);
      return e && e.name ? { "data-language": e.name } : {};
    })
  ]
});
class bi {
  /**
  Create a language support object.
  */
  constructor(t, e = []) {
    this.language = t, this.support = e, this.extension = [t, e];
  }
}
class Xt {
  constructor(t, e) {
    this.specs = t;
    let s;
    function i(a) {
      let l = Ee.newName();
      return (s || (s = /* @__PURE__ */ Object.create(null)))["." + l] = a, l;
    }
    const n = typeof e.all == "string" ? e.all : e.all ? i(e.all) : void 0, o = e.scope;
    this.scope = o instanceof N ? (a) => a.prop(ft) == o.data : o ? (a) => a == o : void 0, this.style = gs(t.map((a) => ({
      tag: a.tag,
      class: a.class || i(Object.assign({}, a, { tag: null }))
    })), {
      all: n
    }).style, this.module = s ? new Ee(s) : null, this.themeType = e.themeType;
  }
  /**
  Create a highlighter style that associates the given styles to
  the given tags. The specs must be objects that hold a style tag
  or array of tags in their `tag` property, and either a single
  `class` property providing a static CSS class (for highlighter
  that rely on external styling), or a
  [`style-mod`](https://github.com/marijnh/style-mod#documentation)-style
  set of CSS properties (which define the styling for those tags).
  
  The CSS rules created for a highlighter will be emitted in the
  order of the spec's properties. That means that for elements that
  have multiple tags associated with them, styles defined further
  down in the list will have a higher CSS precedence than styles
  defined earlier.
  */
  static define(t, e) {
    return new Xt(t, e || {});
  }
}
const ue = /* @__PURE__ */ At.define(), Ss = /* @__PURE__ */ At.define({
  combine(r) {
    return r.length ? [r[0]] : null;
  }
});
function te(r) {
  let t = r.facet(ue);
  return t.length ? t : r.facet(Ss);
}
function ki(r, t) {
  let e = [yi], s;
  return r instanceof Xt && (r.module && e.push(at.styleModule.of(r.module)), s = r.themeType), t != null && t.fallback ? e.push(Ss.of(r)) : s ? e.push(ue.computeN([at.darkTheme], (i) => i.facet(at.darkTheme) == (s == "dark") ? [r] : [])) : e.push(ue.of(r)), e;
}
class Ji {
  constructor(t) {
    this.markCache = /* @__PURE__ */ Object.create(null), this.tree = L(t.state), this.decorations = this.buildDeco(t, te(t.state));
  }
  update(t) {
    let e = L(t.state), s = te(t.state), i = s != te(t.startState);
    e.length < t.view.viewport.to && !i && e.type == this.tree.type ? this.decorations = this.decorations.map(t.changes) : (e != this.tree || t.viewportChanged || i) && (this.tree = e, this.decorations = this.buildDeco(t.view, s));
  }
  buildDeco(t, e) {
    if (!e || !this.tree.length)
      return Q.none;
    let s = new ce();
    for (let { from: i, to: n } of t.visibleRanges)
      di(this.tree, e, (o, a, l) => {
        s.add(o, a, this.markCache[l] || (this.markCache[l] = Q.mark({ class: l })));
      }, i, n);
    return s.finish();
  }
}
const yi = /* @__PURE__ */ ss.high(/* @__PURE__ */ Bt.fromClass(Ji, {
  decorations: (r) => r.decorations
})), wi = /* @__PURE__ */ Object.create(null), _e = [W.none], Xe = [], Ye = /* @__PURE__ */ Object.create(null), Ti = /* @__PURE__ */ Object.create(null);
for (let [r, t] of [
  ["variable", "variableName"],
  ["variable-2", "variableName.special"],
  ["string-2", "string.special"],
  ["def", "variableName.definition"],
  ["tag", "tagName"],
  ["attribute", "attributeName"],
  ["type", "typeName"],
  ["builtin", "variableName.standard"],
  ["qualifier", "modifier"],
  ["error", "invalid"],
  ["header", "heading"],
  ["property", "propertyName"]
])
  Ti[r] = /* @__PURE__ */ Fi(wi, t);
function ee(r, t) {
  Xe.indexOf(r) > -1 || (Xe.push(r), console.warn(t));
}
function Fi(r, t) {
  let e = [];
  for (let a of t.split(" ")) {
    let l = [];
    for (let h of a.split(".")) {
      let u = r[h] || U[h];
      u ? typeof u == "function" ? l.length ? l = l.map(u) : ee(h, `Modifier ${h} used at start of tag`) : l.length ? ee(h, `Tag ${h} used as modifier`) : l = Array.isArray(u) ? u : [u] : ee(h, `Unknown highlighting tag ${h}`);
    }
    for (let h of l)
      e.push(h);
  }
  if (!e.length)
    return 0;
  let s = t.replace(/ /g, "_"), i = s + " " + e.map((a) => a.id), n = Ye[i];
  if (n)
    return n.id;
  let o = Ye[i] = W.define({
    id: _e.length,
    name: s,
    props: [Us({ [s]: e })]
  });
  return _e.push(o), o.id;
}
zt.RTL, zt.LTR;
const vi = (r) => Et.define({
  name: "icu-tolgee",
  parser: _t.configure({
    top: r ? "Nested" : "Root",
    dialect: "tags",
    props: [
      Us({
        TextRoot: U.string,
        Text: U.string,
        PluralPlaceholder: U.keyword,
        VariantDescriptor: U.keyword,
        FormatFunction: U.keyword,
        SelectFunction: U.keyword,
        Param: U.variableName,
        FormatStyle: U.variableName,
        "{ }": U.paren,
        Sep: U.separator,
        "< >": U.tagName,
        Slash: U.tagName,
        TagName: U.tagName
      })
    ]
  })
});
function Li(r) {
  return new bi(vi(r));
}
const Mi = (r) => ki(
  Xt.define([
    { tag: U.variableName, color: r.other },
    { tag: U.keyword, color: r.function },
    { tag: U.bracket, color: r.other },
    { tag: U.tagName, color: r.other },
    { tag: U.content, color: r.main },
    { tag: U.string, color: r.main }
  ])
), Hi = Bt.fromClass(
  class {
    constructor(r) {
      bt(this, "isolates");
      bt(this, "tree");
      this.isolates = Qe(r), this.tree = L(r.state);
    }
    update(r) {
      (r.docChanged || r.viewportChanged || L(r.state) != this.tree) && (this.isolates = Qe(r.view), this.tree = L(r.state));
    }
  },
  {
    provide: (r) => {
      function t(e) {
        var s;
        return ((s = e.plugin(r)) == null ? void 0 : s.isolates) ?? Q.none;
      }
      return ss.lowest([
        at.decorations.of(t),
        at.bidiIsolatedRanges.of(t)
      ]);
    }
  }
), Ri = Q.mark({
  attributes: { style: "direction: ltr; unicode-bidi: isolate" },
  bidiIsolate: zt.LTR
}), Vi = Q.mark({
  attributes: { style: "direction: rtl; unicode-bidi: isolate" },
  bidiIsolate: zt.RTL
});
function Qe(r) {
  const t = new ce();
  for (const { from: e, to: s } of r.visibleRanges)
    L(r.state).iterate({
      from: e,
      to: s,
      enter(i) {
        (i.name === "HtmlTagOpen" || i.name === "HtmlTagClose" || i.name === "Expression") && t.add(i.from, i.to, Ri), (i.name === "TextRoot" || i.name === "Text") && t.add(i.from, i.to, Vi);
      }
    });
  return t.finish();
}
const Ii = {
  variable: {
    border: "#7AD3C1",
    background: "#BEF3E9",
    text: "#008371"
  },
  tag: {
    border: "#F27FA6",
    background: "#F9C4D6",
    text: "#822343"
  },
  variant: {
    border: "#BBC2CB",
    background: "#F0F2F4",
    text: "#4D5B6E"
  }
}, tr = ({
  styled: r,
  colors: t = Ii,
  component: e = "div"
}) => r(e)`
    white-space: pre-wrap;
    & .placeholder-widget {
      display: inline-flex;
      vertical-align: text-top;
      align-items: center;
      justify-content: center;
      min-width: 15px;
      border: 1px solid ${t.variable.border};
      background-color: ${t.variable.background};
      color: ${t.variable.text};
      border-radius: 10px;
      padding: 0px 7px;
      font-size: 12px;
      user-select: none;
      margin: 0px 1px;
      overflow: hidden;

      & > * {
        display: grid;
      }
    }
    & .placeholder-error {
      background: #ff000054;
    }

    & .placeholder-tagOpen {
      border: 1px solid ${t.tag.border};
      background-color: ${t.tag.background};
      color: ${t.tag.text};
      border-radius: 10px 0px 0px 10px;
      padding-right: 6px;
    }

    & .placeholder-tagClose {
      border: 1px solid ${t.tag.border};
      background-color: ${t.tag.background};
      color: ${t.tag.text};
      border-radius: 0px 10px 10px 0px;
      padding-left: 6px;
    }

    // in rtl mode, revert the placeholders direction
    &[dir="rtl"] .placeholder-tagOpen {
      border-radius: 0px 10px 10px 0px;
      padding-left: 6px;
    }
    &[dir="rtl"] .placeholder-tagClose {
      border-radius: 10px 0px 0px 10px;
      padding-right: 6px;
    }
  `, zi = (r) => /^[^\p{White_Space}\p{Pattern_Syntax}]*$/uy.test(r), se = 0, ie = 1, Ke = /* @__PURE__ */ new Set(["{", "}", "#"]), _ = "'", Di = (r) => {
  let t = se;
  const e = [];
  for (const s of r)
    switch (t) {
      case se:
        s === _ ? (e.push(s), t = ie) : Ke.has(s) ? (e.push(_), e.push(s), e.push(_)) : e.push(s);
        break;
      case ie:
        Ke.has(s) ? (e.push(_), e.push(_), e.push(s), e.push(_)) : s === _ ? (e.push(_), e.push(s), e.push(_)) : e.push(s), t = se;
        break;
    }
  return t === ie && e.push(_), e.join("");
}, Ft = 0, re = 1, vt = 2, ne = 3, Ze = /* @__PURE__ */ new Set(["{", "}", "#"]), Le = /* @__PURE__ */ new Set(["{", "}"]), ot = "'", Wi = (r) => {
  let t = Ft;
  const e = [];
  let s;
  for (const i of r)
    switch (t) {
      case Ft:
        i === ot ? t = vt : Le.has(i) && (e.push(ot), s = e.length, t = ne), e.push(i);
        break;
      case vt:
        Ze.has(i) ? (s = e.length, t = re) : t = Ft, e.push(i);
        break;
      case re:
        i === ot ? t = Ft : Ze.has(i) && (s = e.length), e.push(i);
        break;
      case ne:
        i === ot ? (e.splice(s + 1, 0, ot), t = vt) : Le.has(i) && (s = e.length), e.push(i);
        break;
    }
  return [re, ne].includes(t) ? e.splice(s + 1, 0, ot) : t === vt && e.push(ot), e.join("");
};
function Pi(r) {
  return _t.configure({ strict: !0 }).parse(r);
}
const er = (r, t) => {
  const { parameter: e, variants: s } = r;
  if (!e)
    return s.other ?? "";
  if (!zi(e))
    throw new Error(`Parameter name "${e}" is invalid`);
  const i = [`{${e}, plural,`];
  s.other || (s.other = "");
  let n = !0;
  for (const [o, a] of Object.entries(s)) {
    const l = a || "";
    if (n && l && (n = !1), t)
      i.push(` ${o} {${Di(l)}}`);
    else
      try {
        Pi(`{${e}, plural, other {${l}}}`), i.push(` ${o} {${l}}`);
      } catch {
        i.push(` ${o} {${Wi(l)}}`);
      }
  }
  return n ? "" : (i.push("}"), i.join(""));
}, gt = 0, Me = 1, He = 2, Ci = /* @__PURE__ */ new Set(["{", "}", "#"]), Rt = "'", qi = (r) => {
  let t = gt;
  const e = [];
  for (const s of r)
    switch (t) {
      case gt:
        s === Rt ? t = Me : e.push(s);
        break;
      case Me:
        Ci.has(s) ? t = He : (s === Rt || e.push(Rt), t = gt), e.push(s);
        break;
      case He:
        s === Rt ? t = gt : e.push(s);
    }
  return e.join("");
}, ts = {
  0: ge,
  4: Oe,
  5: us,
  // this also excludes 'offset:x'
  6: fs
};
function St(r, t) {
  return t.substring(r.from, r.to);
}
function Ni(r, t, e) {
  let s = r.firstChild;
  do
    if ((s == null ? void 0 : s.type.id) === Ks)
      return e ? qi(St(s, t)) : St(s, t);
  while (s = s == null ? void 0 : s.nextSibling);
  return "";
}
function Ot(r) {
  return { variants: { other: r } };
}
const Ei = (r, t) => {
  let e;
  try {
    e = _t.configure({ strict: !0 }).parse(r);
  } catch {
    return Ot(r);
  }
  const s = e.cursor(), i = {}, n = {}, o = Object.keys(ts), a = Number(o[o.length - 1]);
  for (let h = 0; h <= a; h++) {
    s.next();
    const u = s.node, $ = ts[h];
    if ($ !== void 0)
      if ($ === u.type.id)
        i[u.type.id] = u;
      else
        return Ot(r);
  }
  if (i[ge].nextSibling || St(i[us], r) !== "plural")
    return Ot(r);
  let l = i[fs];
  do {
    const h = St(l.firstChild, r), u = Ni(l, r, t);
    if (n[h] !== void 0)
      return Ot(r);
    n[h] = u;
  } while (l = l.nextSibling);
  return {
    parameter: St(i[Oe], r),
    variants: n
  };
}, sr = (r, t, e = !1) => t ? Ei(r || "", e) : { variants: { other: r } }, Gi = [6, 7, 8, 11, 20, 21, 1e6, 0.5, 0.1, 0], Ai = [0, 2, 3, 4, 6], Bi = [10, 11, 20, 100, 0, 0, 0.1, 2, 3, 4], _i = [
  "zero",
  "one",
  "two",
  "few",
  "many",
  "other"
], ir = (r) => {
  const t = new Set(
    new Intl.PluralRules(r).resolvedOptions().pluralCategories
  );
  return _i.filter((e) => t.has(e));
}, ut = (r, t, e) => {
  const s = new Intl.PluralRules(t);
  return e.find((i) => s.select(i) === r);
}, rr = (r, t) => {
  switch (t) {
    case "zero":
      return ut("zero", r, [0]);
    case "one":
      return ut("one", r, [1]);
    case "two":
      return ut("two", r, [2]);
    case "few":
      return ut("few", r, Ai);
    case "many":
      return ut("many", r, Gi);
    case "other":
      return ut("other", r, Bi);
  }
  const e = Number(t.substring(1));
  return Number.isNaN(e) ? void 0 : e;
}, nr = (r) => {
  const t = [
    "ar",
    "arc",
    "dv",
    "fa",
    "ha",
    "he",
    "khw",
    "ks",
    "ku",
    "ps",
    "ur",
    "yi"
  ], e = r.replace(/^([a-zA-Z]+)(.*?)$/, "$1");
  return t.indexOf(e) > -1 ? "rtl" : "ltr";
};
export {
  Ki as PlaceholderPlugin,
  Mi as TolgeeHighlight,
  zi as checkParamNameIsValid,
  tr as generatePlaceholdersStyle,
  nr as getLanguageDirection,
  ri as getPlaceholders,
  ir as getPluralVariants,
  sr as getTolgeeFormat,
  Ei as getTolgeePlurals,
  rr as getVariantExample,
  Hi as htmlIsolatesPlugin,
  er as tolgeeFormatGenerateIcu,
  _t as tolgeeParser,
  Li as tolgeeSyntax
};
